require "#{GNMSLIB}"+'module/gui/config_window'

class ConfigGlobal
	attr_reader :window
	attr_reader :default_width, :default_height, :default_map, :show_label, :noshow_fqdn, :show_tooltips, :confirm_delete, :confirm_quit, :log_level
	attr_reader :read_community, :write_community, :snmp_version, :snmp_port, :snmp_timeout, :snmp_retry
	attr_reader :mail, :level
	attr_reader :broadcast_ping_state, :broadcast_ping_delay, :mac_state, :mac_delay, :mac_lock, :mac_manufacturer, :syslog_mon, :syslog_port
	attr_reader :node_resolving, :node_resolving_delay
	attr_reader :port_mon, :port_mon_delay, :snmp_mon, :custom_mon
	attr_reader :ping_path, :ip_path, :nmap_path, :snmpget_path, :ssh_path, :telnet_path, :browser_path, :vncviewer_path, :rdesktop_path, :xterm_path, :nmblookup_path, :xprobe_path
	attr_reader :image_path, :bg_type
	attr_reader :rgb, :snmpget
	attr_accessor :pixmap_size
	attr_accessor :host_label_view, :host_icon_view, :network_label_view, :network_icon_view, :map_display_view
   attr_accessor :nmap_vers

#
#	save configuration to file, refresh general value
#
def save_config()

   fic_tmp=Tempfile.new(File.basename(GLOBAL_CONF_FILE))
  
	line_idx=0
	File.readlines(GLOBAL_CONF_FILE).each{|line|
		if line_idx == 1
		  fic_tmp.puts("#{get_map_width()}")
		  fic_tmp.puts("#{get_map_height()}")
		  fic_tmp.puts("#{$map}")
		  fic_tmp.puts("#{$config.host_label_view}")
		  fic_tmp.puts("#{$config.host_icon_view}")
		  fic_tmp.puts("#{$config.network_label_view}")
		  fic_tmp.puts("#{$config.network_icon_view}")
		  fic_tmp.puts("#{$config.map_display_view}")
		end
		#we rewrite all exept GENERAL paragrapher
		if (line_idx == 0) || (line_idx > 8)
			fic_tmp.print line
		end
		line_idx+=1		
	}
	fic_tmp.close
	if File.stat(fic_tmp.path).size?
		#all seems good
  		File.rename(fic_tmp.path, GLOBAL_CONF_FILE)
	end

end

#
#	read configuration file
#
def read_config()

if FileTest.exist?(GLOBAL_CONF_FILE)
  fic = File.new(GLOBAL_CONF_FILE,'r')

  fic.gets() #[GENERAL]
  @default_width = fic.gets().chop()
  @default_height = fic.gets().chop()
  @default_map	= fic.gets().chop()
  @host_label_view	= fic.gets().chop()
  @host_icon_view	= fic.gets().chop()
  @network_label_view	= fic.gets().chop()
  @network_icon_view	= fic.gets().chop()
  @map_display_view = fic.gets().chop()
  @show_label = fic.gets().chop()
  @noshow_fqdn = fic.gets().chop()
  @show_tooltips = fic.gets().chop()
  @confirm_delete = fic.gets().chop()
  @confirm_quit = fic.gets().chop()
  @log_level = fic.gets().chop()

  fic.gets()  #[SNMP]
  @read_community = fic.gets().chop()
  @write_community = fic.gets().chop()
  @snmp_version = fic.gets().chop()
  @snmp_port = fic.gets().chop()
  @snmp_timeout = fic.gets().chop()
  @snmp_retry = fic.gets().chop()

  fic.gets() #"[ADMIN]"
  @mail = fic.gets().chop()
  @level = fic.gets().chop()
  for l in $LEVEL
	 val = fic.gets().chop()
	 tval = val.split(/,/)
	 for ty in 0..$talert_type.size - 1
   	$level_alert_type[l][ty]=to_b(tval[ty])
	 end
  end  

  fic.gets() # "[SCAN]"
  @broadcast_ping_state = fic.gets().chop()
  @broadcast_ping_delay = fic.gets().chop()
  @mac_state = fic.gets().chop()
  @mac_delay = fic.gets().chop()
  @mac_lock = fic.gets().chop()
  @mac_manufacturer = fic.gets().chop()
  @node_resolving = fic.gets().chop() 
  @node_resolving_delay = fic.gets().chop() 
  @port_mon = fic.gets().chop()
  @port_mon_delay = fic.gets().chop()
  @snmp_mon = fic.gets().chop()
  @custom_mon = fic.gets().chop()
  @syslog_mon = fic.gets().chop()
  @syslog_port = fic.gets().chop()

  fic.gets() #"[PATH]"
  @ping_path = fic.gets().chop()
  @ip_path = fic.gets().chop()
  @nmap_path = fic.gets().chop()
  @snmpget_path = fic.gets().chop()
  @ssh_path = fic.gets().chop()
  @telnet_path = fic.gets().chop()
  @browser_path = fic.gets().chop()
  @vncviewer_path = fic.gets().chop()
  @rdesktop_path = fic.gets().chop()
  @xterm_path = fic.gets().chop()
  @nmblookup_path = fic.gets().chop()
  @xprobe_path = fic.gets().chop()

  fic.gets() #"[KEYS]"

  fic.gets() #"[COLORS]"
  @pixmap_size = fic.gets().chop().to_i
  @bg_type = fic.gets().chop()
  @rgb=[]
  @rgb[0] = fic.gets().chop()
  @rgb[1] = fic.gets().chop()
  @rgb[2] = fic.gets().chop()
  @image_path = fic.gets().chop()

  fic.close()
  @snmpget = "#{@snmpget_path} -t #{@snmp_timeout} -r #{@snmp_retry} "
  else
		#we set some var
		@host_label_view="dns_name"
		@host_icon_view="type"
		@network_label_view="ip"
		@network_icon_view="type"
		@map_display_view="User defined"
 	   #map is set in mail
		@show_label=true
		@noshow_fqdn=false
		@show_tooltips=false
		@confirm_delete=true
		@confirm_quit=true
		@log_level="Info"
		@pixmap_size=35
		@bg_type="color"
		#grey
		@rgb=[48251, 45824, 45824]
  end
end

def show()
	@window.show()
end

def initialize ()

	@rgb = [1,1,1]
	@image_path = "#{PIXMAP_PATH}/bg"
	@bg_type = "color"
	#set this for the first time we launch gnms
	@port_mon_delay = "60" 
	@broadcast_ping_delay = "300"
	@node_resolving_delay = "120"
	@mac_delay = "60"
	@syslog_port="514"

	@window=ConfigWindow.new(self)
end


end
