#
# here we can find Gtk::Window for add or del an host
#

#
# error window
#
def errorEntry(win, ent)
	lbl="You have to fill IP entry"
	if ent != ""
		lbl="Syntax Error in '#{ent}'"
	end
   dialog = Gtk::MessageDialog.new(win, Gtk::Dialog::DESTROY_WITH_PARENT,
                             Gtk::MessageDialog::ERROR,
                             Gtk::MessageDialog::BUTTONS_OK,
                             lbl)
	dialog.run
	dialog.destroy
end

###############################################################################################
# window to add an host
#
def addnodewin()

  if $win == nil
    return
  end

  addwin=Gtk::Window.new
  addwin.set_transient_for($win)
  addwin.set_title("Node host adding")
  addwin.set_size_request(350, 270)
  addwin.set_modal(true)

  addwin.signal_connect("key_press_event") {|w,e|
    if e.keyval == Gdk::Keyval::GDK_Escape
      addwin.destroy
    end
  }

  frame = Gtk::Frame::new("Add a host")
  frame.border_width=10
  frame.show
  vbox_root=Gtk::VBox::new
  vbox_root.show
  addwin.add vbox_root
  vbox_root.add frame

  vbox = Gtk::VBox.new
  vbox.show
  frame.add vbox

  ent = Gnome::IconEntry.new("Foo","Icon")
  ent.set_pixmap_subdir("#{PIXMAP_PATH}/type")
  ent.filename="#{PIXMAP_PATH}/type/"
  ent.show
  vbox.add ent

  table = Gtk::Table.new(8,2,false)
  table.show

  #set_editable set_visibility set_sensitive set_text
  entry_ip = Gtk::Entry.new
  entry_ip.show

  label_ip = Gtk::Label.new "IP"
  label_ip.show

  table.attach(label_ip,0,1,0,1)
  table.attach(entry_ip,1,2,0,1)

  hbox = Gtk::HBox.new
  hbox.show
  entry_netmask = Gtk::Entry.new
  entry_netmask.set_text "255.255.255.0"
  entry_netmask.set_editable false
  entry_netmask.show

  adj = Gtk::Adjustment::new(0, 1.0, 32.0, 1.0, 5.0, 0.0)
  compressnetmask = Gtk::SpinButton::new(adj, 0, 0)
  compressnetmask.set_wrap(true)
  compressnetmask.set_editable false
  compressnetmask.set_value 24.0

  compressnetmask.show
  hbox.add entry_netmask
  hbox.add compressnetmask
  label_netmask = Gtk::Label.new "Mask"
  label_netmask.show
  table.attach(label_netmask,0,1,1,2)
  table.attach(hbox,1,2,1,2)

  compressnetmask.signal_connect("value-changed") {
    entry_netmask.set_text bit2netmask(compressnetmask.value_as_int)
  }

  entry_name = Gtk::Entry.new
  #entry_name.select_region(0, 5)
  entry_name.show

  label_name = Gtk::Label.new "DNS name"
  label_name.show

  table.attach(label_name,0,1,2,3)
  table.attach(entry_name,1,2,2,3)

  label_map = Gtk::Label.new "Map"
  label_map.show
  entry_map = Gtk::Combo.new
  entry_map.entry.set_editable false
  entry_map.set_use_arrows true
  entry_map.set_popdown_strings(get_network())
  if get_map() != nil
	  entry_map.entry.set_text(get_map())
  end
  entry_map.show

  table.attach(label_map,0,1,3,4)
  table.attach(entry_map,1,2,3,4)

  entry_description = Gtk::Entry.new
  #entry_description.select_region(0, 5)
  entry_description.show
  label_description = Gtk::Label.new "Description"
  label_description.show

  table.attach(label_description,0,1,4,5)
  table.attach(entry_description,1,2,4,5)

  bbox =Gtk::HBox::new(FALSE, 10)
  bbox.border_width=10
  bbox.show

  ok_button = Gtk::Button.new("Ok")
  ok_button.show
  ok_button.signal_connect("clicked") {
	  if ent.filename == nil
   	 nnodepix = "os/unknown.png"
	  else
   	 nnodepix = ent.filename
	  end

	  if isValidIp(entry_ip.text)
   	 if entry_name.text == ""
      	entry_name.set_text Node::NONAME_PROPERTY
   	 end

   	 if entry_description.text == ""
      	entry_description.set_text Node::NODESCR_PROPERTY
   	 end

   	 lentry=entry_ip.text.split(/\./)
   	 if lentry[3] == "0" || lentry[3] == "255"
      	#add a network
			puts "Seems that it's a network! Trying to add it"
      	mask=compressnetmask.value_as_int
      	tfindremotehost(entry_ip.text,mask)
   	 else
      	if ! $host[entry_ip.text]
				#we dont use add_host, here we can set more attribute
				$host[entry_ip.text]=Host.new(entry_ip.text,compressnetmask.value_as_int,entry_map.entry.text,Node::NOARP_PROPERTY,entry_name.text,Node::NONAME_PROPERTY,"",UNKNOWN,0,0, nnodepix,entry_description.text,"public","public","pc","unknown")
				$network[entry_map.entry.text].add_host($host[entry_ip.text])
				$host[entry_ip.text].reload()
				#now we need to force node view drawing
				$host[entry_ip.text].node_view.show() if entry_map.entry.text=get_map()
				$event_win.add_event("core", "INFO", "#{entry_ip.text}", "Host added")
      	end
   	 end
   	 addwin.destroy 
	  else 
   	 errorEntry(addwin, entry_ip.text)
	  end
  }

  cancel_button = Gtk::Button.new("Cancel")
  cancel_button.show
  cancel_button.signal_connect("clicked") {
    addwin.destroy 

  }

  ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
  bbox.pack_start(ok_button, TRUE, TRUE, 0)
  cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
  bbox.pack_start(cancel_button, TRUE, TRUE, 0)

  vbox.add(table)
  separator = Gtk::HSeparator::new()
  separator.show
  vbox_root.pack_start(separator, FALSE, TRUE, 0)
  vbox_root.pack_start(bbox, FALSE, TRUE, 0)


  addwin.show
end

###############################################################################################
# window to delete an host
#
def delnodewin(node)
  
	#test if is not the root network
	if node.map == nil
		return
	end

	mode=1
	if node.class == Array
		#multiple nodes!
		mode=2
	end

  if to_b($config.confirm_delete)
	  label=""
	  if mode == 1
		  if node.ip == ""
   		 label = "Do you really want to delete this node ?"
		  else
   		 label = "Do you want to delete '#{node.ip}' ?"
		  end
		else
			#test if there more than 1 node in the array
			if node.size > 1
				label = "Do you really want to delete these nodes ?"
			else
				label = "Do you want to delete '#{node[0].ip}' ?"		
			end
     end
     dialog = Gtk::MessageDialog.new($win, Gtk::Dialog::DESTROY_WITH_PARENT,
                           	 Gtk::MessageDialog::QUESTION,
                           	 Gtk::MessageDialog::BUTTONS_YES_NO,
                           	 label)
	  dialog.run do |r|
		  dialog.destroy
		  if r == Gtk::Dialog::RESPONSE_YES then
			  if mode == 1
   			$event_win.add_event("core", "INFO", "#{node.ip}", "Host removed")
   			node.delete()
			  else
				  node.each {|n|
   				 $event_win.add_event("core", "INFO", "#{n.ip}", "Host removed")
   				 n.delete()
				  }
			  end
		  end	
	  end
	else
		#dont show confirm popup
		if mode == 1
   	 $event_win.add_event("core", "INFO", "#{node.ip}", "Host removed")
   	 node.delete()
		else
			node.each {|n|
   		  $event_win.add_event("core", "INFO", "#{n.ip}", "Host removed")
   		  n.delete()
			}
		end
	end
end

###############################################################################################
# window to add a range of host node
#
def addhostrange()
    if $win == nil
  	    return
    end

    addwin=Gtk::Window.new

    addwin.set_title("Node network adding")
    addwin.set_size_request(350, 150)
    addwin.set_modal(true)

   addwin.signal_connect("key_press_event") {|w,e|
      if e.keyval == Gdk::Keyval::GDK_Escape
			addwin.destroy
      end
    }

    frame = Gtk::Frame::new("Add host range")
    frame.border_width=10
    frame.show
    vbox_root=Gtk::VBox::new
    vbox_root.show
    addwin.add vbox_root
    vbox_root.add frame
    vbox = Gtk::VBox.new
    vbox.show
    frame.add vbox

    table = Gtk::Table.new(3,2,false)
    table.show

    hostalivetoo = Gtk::CheckButton.new("Add alive hosts in range")
    hostalivetoo.show

    label_ip = Gtk::Label.new "IP"
    label_ip.show

    hbox = Gtk::HBox.new
    hbox.show
    entry_ip = Gtk::Entry.new
	 entry_ip.show
    entry_ip_end = Gtk::Entry.new
	 entry_ip_end.set_size_request(10,-1)
	 entry_ip_end.show
	 hbox.add entry_ip
	 hbox.add entry_ip_end

    table.attach(label_ip,0,1,0,1)
    table.attach(hbox,1,2,0,1)

    ok_button = Gtk::Button.new("Ok")
    ok_button.show
    ok_button.signal_connect("clicked") {

    if isValidIp(entry_ip.text) && isInteger(entry_ip_end.text)
       if hostalivetoo.active?
    	   tfindrangeremotehost(entry_ip.text, entry_ip_end.text)
       else
	    	lentry=entry_ip.text.split(/\./)
			ip_addr="#{lentry[0]}.#{lentry[1]}.#{lentry[3]}."	
			limit_inf=lentry[3].to_i()
			limit_sup=entry_ip_end.text.to_i()
			if limit_inf > limit_sup
				limit_tmp=limit_inf
				limit_inf=limit_sup
				limit_sup=limit_tmp
			end
			for ip in limit_inf..limit_sup
 	   		add_host(ip_addr+"#{ip}", 24, get_map())
			end
       end
       addwin.destroy 
    else
		 if isInteger(entry_ip_end.text)
  	    	errorEntry(addwin, entry_ip.text)
		 else
  	    	errorEntry(addwin, entry_ip_end.text)
		 end
    end
    }

    cancel_button = Gtk::Button.new("Cancel")
    cancel_button.show
    cancel_button.signal_connect("clicked") {
  	    addwin.destroy 
    }

	 bbox =Gtk::HBox::new(FALSE, 10)
	 bbox.border_width=10
	 bbox.show

	 ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(ok_button, TRUE, TRUE, 0)
	 cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(cancel_button, TRUE, TRUE, 0)

	 vbox.add(table)
	 vbox.add hostalivetoo
	 separator = Gtk::HSeparator::new()
	 separator.show
	 vbox_root.pack_start(separator, FALSE, TRUE, 0)
	 vbox_root.pack_start(bbox, FALSE, TRUE, 0)

    addwin.show
end



###############################################################################################
# window to add a network
#
def addnetworkwin
    if $win == nil
  	    return
    end

    addwin=Gtk::Window.new

    addwin.set_title("Node network adding")
    addwin.set_size_request(350, 200)
    addwin.set_modal(true)

   addwin.signal_connect("key_press_event") {|w,e|
      if e.keyval == Gdk::Keyval::GDK_Escape
			addwin.destroy
      end
    }

    frame = Gtk::Frame::new("Add Network")
    frame.border_width=10
    frame.show
    vbox_root=Gtk::VBox::new
    vbox_root.show
    addwin.add vbox_root
    vbox_root.add frame
    vbox = Gtk::VBox.new
    vbox.show
    frame.add vbox

    table = Gtk::Table.new(3,2,false)
    table.show

    hostalivetoo = Gtk::CheckButton.new("Add alive host in network")
    hostalivetoo.show

    label_ip = Gtk::Label.new "IP"
    label_ip.show
    entry_ip = Gtk::Entry.new
    entry_ip.show

    table.attach(label_ip,0,1,0,1)
    table.attach(entry_ip,1,2,0,1)
    label_netmask = Gtk::Label.new "Netmask"
    label_netmask.show
	
    hbox = Gtk::HBox.new
    hbox.show
    entry_netmask = Gtk::Entry.new
    entry_netmask.set_text "255.255.255.0"
    entry_netmask.set_editable false
    entry_netmask.show
  
    adj = Gtk::Adjustment::new(0, 1.0, 32.0, 1.0, 5.0, 0.0)
    compressnetmask = Gtk::SpinButton::new(adj, 0, 0)
    compressnetmask.set_wrap(true)
    compressnetmask.set_editable false
    compressnetmask.set_value 24.0

    compressnetmask.show
    hbox.add entry_netmask
    hbox.add compressnetmask
    table.attach(label_netmask,0,1,1,2)
    table.attach(hbox,1,2,1,2)

    compressnetmask.signal_connect("value-changed") {
      entry_netmask.set_text bit2netmask(compressnetmask.value_as_int)
    }

    ok_button = Gtk::Button.new("Ok")
    ok_button.show
    ok_button.signal_connect("clicked") {

    if isValidIp(entry_ip.text)
       lentry=entry_ip.text.split(/\./)
       if hostalivetoo.active?
    	   tfindremotehost(entry_ip.text,compressnetmask.value_as_int)
       else
	   	add_network(entry_ip.text, compressnetmask.value_as_int, get_map())
       end
       addwin.destroy 
    else 
  	    errorEntry(addwin, entry_ip.text)
    end
    }

    cancel_button = Gtk::Button.new("Cancel")
    cancel_button.show
    cancel_button.signal_connect("clicked") {
  	    addwin.destroy 
    }

	 bbox =Gtk::HBox::new(FALSE, 10)
	 bbox.border_width=10
	 bbox.show

	 ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(ok_button, TRUE, TRUE, 0)
	 cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(cancel_button, TRUE, TRUE, 0)

	 vbox.add(table)
	 vbox.add hostalivetoo
	 separator = Gtk::HSeparator::new()
	 separator.show
	 vbox_root.pack_start(separator, FALSE, TRUE, 0)
	 vbox_root.pack_start(bbox, FALSE, TRUE, 0)

    addwin.show
end

###############################################################################################
def adddomainwin
end
