=begin header

  base window

=end

require 'gtk2'
require 'gnome2'
require "#{GNMSLIB}"+'module/gui/help_window'
require "#{GNMSLIB}"+'module/gui/update_window'
require "#{GNMSLIB}"+'module/gui/oid_ref_window'
require "#{GNMSLIB}"+'module/gui/syslog_ref_window'
require "#{GNMSLIB}"+'module/gui/mib_browser'
require "#{GNMSLIB}"+'module/gui/find_node_window'
require "#{GNMSLIB}"+'module/gui/color_macro'
require "#{GNMSLIB}"+'module/gui/treenode_window'
require "#{GNMSLIB}"+'module/gui/ipcalculator'
require "#{GNMSLIB}"+'module/custom_monitor'
require "#{GNMSLIB}"+'module/config_global'
require "#{GNMSLIB}"+'module/nodedb'

#we load plugins rb files
lfile = Dir["plugins/*.rb"]
cptCustomMon=0
for pluginsfile in lfile
	require pluginsfile

	pluginsfile=pluginsfile[8,pluginsfile.size - 8 - 3]
	cmd="#{pluginsfile[0,1].capitalize()}#{pluginsfile[1,pluginsfile.size - 1]}"
	if (eval cmd).superclass==CustomMonitor
		cptCustomMon+=1
	   #create custom monitor table if needed
		if !defined?($custom_monitor)
			$custom_monitor=[]
		end
		$custom_monitor.push(cmd)
	end
end
if cptCustomMon>0
		  $log.info("Find #{cptCustomMon} custom monitor plugin(s)")
end

class App < Gnome::App
  include Gnome::I18n

def N_ (text)
	return text
end

def set_map_display_view_user_defined()
	$config.map_display_view="User defined"
end

def hide_menu_entry()
	@ag.get_action("Add host").sensitive=false
	@ag.get_action("Add network").sensitive=false
	@ag.get_action("Add host range").sensitive=false
end

def show_menu_entry()
	@ag.get_action("Add host").sensitive=true
	@ag.get_action("Add network").sensitive=true
	@ag.get_action("Add host range").sensitive=true
end

def hide_menu()
	@main_vbox.remove(@main_bar)
end

def show_menu()
	@main_bar.height_request=30
	@main_vbox.pack_start(@main_bar,false)
	@main_vbox.reorder_child(@main_bar,0)
end

  def check_update()
	check_update_window()
  end


  def initialize(appname, title)
    super(appname, title)

    pluginslist=[]
    create_plugins_list(pluginslist)

proc_map_window=Proc.new {|action, current|
	$config.map_display_view=current.name
	if current.name == "25% screen"
		map_window_activ_quart()
	elsif current.name == "50% screen"
		map_window_activ_half()
	elsif current.name == "100% screen"
		map_window_activ_full()
	elsif current.name == "Full screen"
		$canvas.toggle_fullscreen()
	end

}

proc_icon=Proc.new  {|action, current|
	if current.name.index("host")
	  if current.name == "host_type"
		 $config.host_icon_view="type"
	  	 host_icon()
	  else
		 $config.host_icon_view="os"
	  	 host_icon()
	  end
	else
		if current.name == "network_type"
			$config.network_icon_view="type"
			network_icon()
		else
			$config.network_icon_view="os"
			network_icon()
		end
	end
}
proc_label=Proc.new {|action, current|
	if current.name.index("host")
		if current.name == "host_dns_name"
			 $config.host_label_view="dns_name"
			 host_label()
		 elsif current.name == "host_netbios_name"
			 $config.host_label_view="netbios_name"
			 host_label()
		 elsif current.name == "host_ip"
			 $config.host_label_view="ip"
			 host_label()
		 elsif current.name == "host_osl"
		    $config.host_label_view="os"
			 host_label()
		 elsif current.name == "host_mac"
			 $config.host_label_view="mac"
			 host_label()
		 elsif current.name == "host_mac_manufacturer"
			 $config.host_label_view="mac_manufacturer"
			 host_label()
		 elsif current.name == "host_description"
			 $config.host_label_view="description"
			 host_label()
		 end
	else
		case current.name
		when "network_name"
			$config.network_label_view="name"
			network_label()
		when "network_dns_domain"
		   $config.network_label_view="dns_domain"
			network_label()
		when "network_netbios_domain"
	 	   $config.network_label_view="netbios_domain"
			network_label()
		when "network_ip"
	 	 	$config.network_label_view="ip"
			network_label()
		when "network_osl"
    		$config.network_label_view="os"
			network_label()
		when "network_description"
			$config.network_label_view="description"
			network_label()
		end
	end
}

plugins_list_xml=""
list_plugins().each {|plugin_name|
	plugins_list_xml="#{plugins_list_xml}\n<menuitem action='#{plugin_name}'/>"
}

main_menu = %Q[
<ui>
  <menubar name='MainBar'>
    <menu action='FileMenu'>
      <menuitem action='New'/>
      <menuitem action='Open'/>
      <menuitem action='Save log'/>
      <menuitem action='Save map'/>
      <menuitem action='Save map as'/>
      <menuitem action='Snapshot'/>
      <separator/>
      <menuitem action='Quit'/>
    </menu>
    <menu action='ViewMenu'>
      <menuitem action='Add host'/>
      <menuitem action='Add network'/>
      <menuitem action='Add host range'/>
      <separator/>
		<menu action='LabelMenu'>
      	<menu action='LabelHostMenu'>
				<menuitem action='host_dns_name'/>
				<menuitem action='host_netbios_name'/>
				<menuitem action='host_ip'/>
				<menuitem action='host_osl'/>
				<menuitem action='host_mac'/>
				<menuitem action='host_mac_manufacturer'/>
				<menuitem action='host_description'/>
      	</menu>
      	<menu action='LabelNetworkMenu'>
				<menuitem action='network_name'/>
				<menuitem action='network_dns_domain'/>
				<menuitem action='network_netbios_domain'/>
				<menuitem action='network_ip'/>
				<menuitem action='network_osl'/>
				<menuitem action='network_description'/>
      	</menu>
		</menu>
		<menu action='IconMenu'>
      	<menu action='IconHostMenu'>
				<menuitem action='host_osi'/>
				<menuitem action='host_type'/>
      	</menu>
      	<menu action='IconNetworkMenu'>
				<menuitem action='network_osi'/>
				<menuitem action='network_type'/>
      	</menu>
		</menu>
      <separator/>
      <menuitem action='Select all nodes'/>
      <menuitem action='Switch selected nodes'/>
      <separator/>
      <menuitem action='Zoom in'/>
      <menuitem action='Zoom out'/>
    </menu>
    <menu action='OptionMenu'>
      <menuitem action='Preference'/>
      <menu action='MapWindowMenu'>
        <menuitem action='User defined'/>
        <menuitem action='25% screen'/>
        <menuitem action='50% screen'/>
        <menuitem action='100% screen'/>
        <menuitem action='Full screen'/>
      </menu>
    </menu>
    <menu action='ToolsMenu'>
      <menuitem action='Node Tree'/>
      <menuitem action='Node Find'/>
		<menuitem action='Event browser'/>
      <menuitem action='SNMP OID conf'/>
      <menuitem action='Syslog Ref conf'/>
      <menuitem action='MIB browser'/>
      <menuitem action='IP calculator'/>
    </menu>
    <menu action='PluginMenu'>
#{plugins_list_xml}
    </menu>
    <menu action='HelpMenu'>
      <menuitem action='Help'/>
      <menuitem action='Update'/>
      <menuitem action='About...'/>
    </menu>
  </menubar>
</ui>]

#we need to have an action_procs!
@action_procs=actions = [
  ["FileMenu", nil, "_File"],
  ["New", Gtk::Stock::NEW, "_New", "<control>N", "Create a new map", proc{ new_map }],
  ["Open", Gtk::Stock::OPEN, "_Open", "<control>O", "Open a map", proc{ open_file }],
  ["Save log", Gtk::Stock::SAVE, "Save _Log", "<control>L", "Save current log", proc{ $event_win.save_event() }],
  ["Save map", Gtk::Stock::SAVE, "_Save Map", "<control>S", "Save map", proc{ save }],
  ["Save map as", Gtk::Stock::SAVE, "Save Ma_p As...", "<control>P", "Save map to a file", proc{ save_as }],
  ["Snapshot", Gtk::Stock::PRINT, "Snap Shot", nil, "Take a snapshot", proc{ snapshot }],
  ["Quit", Gtk::Stock::QUIT, "_Quit", "<control>Q", "Quit", proc{ quit_now }],
  ["ViewMenu", nil, "View"],
  ["Add host", nil, "Add host", nil, "", proc { addnodewin }],
  ["Add network", nil, "Add network", nil, "", proc { addnetworkwin }],
  ["Add host range", nil, "Add host range", nil, "", proc { addhostrange }],
  ["LabelMenu", nil, "Node label"],
  ["IconMenu", nil, "Node icon"],
  ["LabelHostMenu", nil, "Host as"],
  ["IconHostMenu", nil, "Host as"],
  ["LabelNetworkMenu", nil, "Network as"],
  ["IconNetworkMenu", nil, "Network as"],
  ["Select all nodes", nil, "Select _all nodes", "<control>A", "", proc { select_all_node() }],
  ["Switch selected nodes", nil, "Sw_itch selected nodes", "<control>I", "", proc { invert_selected_node() }],
  ["Zoom in", nil, "Zoom in", "KP_Add", "", proc { $canvas.node_view_zoom_in() }],
  ["Zoom out", nil, "Zoom out", "KP_Subtract", "", proc { $canvas.node_view_zoom_out() }],
  ["OptionMenu", nil, "Option"],
  ["Preference", nil, "Preference", nil, "", proc { create_config_option } ],
  ["MapWindowMenu", nil, "Map window"],
  ["ToolsMenu", nil, "Tools"],
  ["Node Tree", nil, "Node _Tree", "<control>T", "", proc { $treenode_win.show() }],
  ["Node Find", nil, "Node _Find", "<control>F", "", proc { findnodewin }],
  ["Event browser", nil, "_Event browser", "<control>E", "", proc { $event_win.show() }],
  ["SNMP OID conf", nil, "SNMP OID conf", "", "", proc { OIDRefWindow.new() }],
  ["Syslog Ref conf", nil, "Syslog Ref conf", "", "", proc { SyslogRefWindow.new() }],
  ["MIB browser", nil, "_MIB browser", "<control>M", "", proc { mib_browser }],
  ["IP calculator", nil, "IP _calculator", "<control>C", "", proc { netmask_calculator} ],
  ["PluginMenu", nil, "Plugins"],
  ["HelpMenu", nil, "Help"],
  ["Help", nil, "Help", nil, "", proc{ create_help }],
  ["Update", nil, "Check update", nil, "", proc{ check_update }],
  ["About...", nil, "About", nil, "About", proc{ create_about }]
]
$log.info("#{pluginslist.length()} plugin(s) loaded")
if pluginslist.length()
	actions=actions+pluginslist
end

map_window_radio_actions = [
  ["User defined", nil, "User defined", nil, "User defined", 0],
  ["25% screen", nil, "25% screen", nil, "25% screen", 1],
  ["50% screen", nil, "50% screen", nil, "50% screen", 2],
  ["100% screen", nil, "100% screen", nil, "100% screen", 3],
  ["Full screen", nil, "Full screen", nil, "Full screen", 4]
]

node_host_label_radio_actions = [
  ["host_dns_name", nil, "DNS Name", nil, "DNS Name", 0],
  ["host_netbios_name", nil, "Netbios Name", nil, "Netbios Name", 1],
  ["host_ip", nil, "IP", nil, "IP", 2],
  ["host_osl", nil, "OS", nil, "OS", 3],
  ["host_mac", nil, "MAC", nil, "MAC", 4],
  ["host_mac_manufacturer", nil, "MAC manufacturer", nil, "MAC manufacturer", 5],
  ["host_description", nil, "Description", nil, "Description", 6]
]

node_network_label_radio_actions = [
  ["network_name", nil, "Name", nil, "Name", 0],
  ["network_dns_domain", nil, "DNS Domain", nil, "DNS Domain", 1],
  ["network_netbios_domain", nil, "Netbios Domain", nil, "Netbios Domain", 2],
  ["network_ip", nil, "IP", nil, "IP", 3],
  ["network_osl", nil, "OS", nil, "OS", 4],
  ["network_description", nil, "Description", nil, "Description", 5]
]

node_host_icon_radio_actions = [
  ["host_osi", nil, "OS", nil, "OS", 0],
  ["host_type", nil, "Type", nil, "Type", 1]
]
node_network_icon_radio_actions=[
  ["network_osi", nil, "OS", nil, "OS", 0],
  ["network_type", nil, "Type", nil, "Type", 1]
]
  @ag=actiongroup = Gtk::ActionGroup.new("Actions")
  actiongroup.add_actions(actions)

  map_display=0
  map_window_radio_actions.each do |tab|
	if $config.map_display_view == tab[0]
		map_display=tab[5]
	end
  end
  actiongroup.add_radio_actions(map_window_radio_actions, map_display, proc_map_window )
  label_view_pos=0
  node_host_label_radio_actions.each do |tab|
		if ("host_#{$config.host_label_view}" == tab[0]) || ("host_#{$config.host_label_view}l" == tab[0])
			break
		end
		label_view_pos+=1
  end
  actiongroup.add_radio_actions(node_host_label_radio_actions, label_view_pos, proc_label )

  label_view_pos=0
  node_network_label_radio_actions.each do |tab|
		if ("network_#{$config.network_label_view}" == tab[0]) || ("network_#{$config.network_label_view}l" == tab[0])
			break
		end
		label_view_pos+=1
  end
  actiongroup.add_radio_actions(node_network_label_radio_actions, label_view_pos, proc_label )
  
  icon_view_pos=0
  node_host_icon_radio_actions.each do |tab|
		if ("host_#{$config.host_icon_view}" == tab[0]) || ("host_#{$config.host_icon_view}i" == tab[0])
			break
		end
		icon_view_pos+=1
  end
  actiongroup.add_radio_actions(node_host_icon_radio_actions, icon_view_pos, proc_icon )

  icon_view_pos=0
  node_network_icon_radio_actions.each do |tab|
		if ("network_#{$config.network_icon_view}" == tab[0]) || ("network_#{$config.network_icon_view}i" == tab[0])
			break
		end
		icon_view_pos+=1
  end
  actiongroup.add_radio_actions(node_network_icon_radio_actions, icon_view_pos, proc_icon )

  uimanager = Gtk::UIManager.new
  uimanager.insert_action_group(actiongroup, 0)
  add_accel_group(uimanager.accel_group)
  uimanager.add_ui(main_menu)
  @main_bar=uimanager.get_widget("/MainBar")
  #we set height size then we could set the canvas scroll region
  @main_bar.height_request=30

  $canvas=CanvasMap.new(true)
  $canvas_root=$canvas.get_root()

  @main_vbox = Gtk::VBox.new()

  @main_vbox.pack_start(@main_bar, false)
  @main_vbox.pack_start($canvas, true, true)
    @main_vbox.signal_connect('size-allocate') { |w,e|
		#put display
		set_map_display_view_user_defined()
#print "here dans set_size ",e.width," ",e.height,"\n"
		height=e.height
		if !$canvas.fullscreen?()
			height-=@main_bar.height_request
		else
			#we need to store $win size!
			$root_width=$win.window.geometry[2]
			$root_height=$win.window.geometry[3]
		end
		$canvas.set_size(e.width,height)
   	false
    }

  set_contents(@main_vbox)

	#on startup we hide some menu entries
  hide_menu_entry()

   end

	def list_plugins()
		tab_result=[]
		lfile = Dir["plugins/*.rb"]
		for nm in lfile
		  	#we delete path and type (.rb)
			nm=nm[8,nm.size - 8 - 3]
			tab_result.push(nm)
      end
		return tab_result
	end

  private
	def create_plugins_list (pluginslist)
		launch_plugin = Proc.new do |action, plugin|
		cmd=plugin.name
		cmd="#{cmd[0,1].capitalize()}#{cmd[1,cmd.size - 1]}"
        	 #use thread to prevent crash from bogus name with file & class
         	 Thread.start {
         	  (eval cmd).new
         	 }
		end
	  list_plugins().each {|plugin_name|
		  pluginslist.push(["#{plugin_name}", nil, "#{plugin_name}", nil, "", launch_plugin ])
	  }
  end
 
#####begin host node icon#####################
private
  def host_icon()
	if get_map() != nil
	 $network[get_map()].host.each_value {|n|
			if n.class == Host
			   n.reload
			end
	 }
	end
  end
#####end host node icon#####################

#####begin network node icon#####################
private
  def network_icon()
	if get_map() != nil
    $network[get_map()].host.each_value {|n|
			if n.class == Network
			   n.reload()
			end
	 }
	else
		$network[ROOTMAPADDR].reload()
	end
  end
#####end network node icon#####################

#####begin host node label#####################
  private
  def host_label()
	if get_map() != nil
	 $network[get_map()].host.each_value {|n|
			if n.class == Host
			   n.change_label($config.host_label_view)
			end
	 }
	end
  end
 
#####end host node label#####################

#####begin network node label#####################
  private
  def network_label()
	if get_map() != ROOTMAPADDR
	 $network[get_map()].host.each_value {|n|
			if n.class == Network
			   n.change_label($config.network_label_view)
			end
	 }
	else
		   $network[ROOTMAPADDR].change_label($config.network_label_view)
	end
  end
 
#####end network node label#####################
  
####################################################################################################
#
# Modify node position to keep relative position from the window
#
public
def proportional_node_position(wold, hold,w,h)
	#print w, " ", h, " ", wold," ",hold,"\n"

#FIXME2: do it for current node and map
  #$host.each_key {|ip|
   # xp=$host[ip].x / wold.to_f
   # yp=$host[ip].y / hold.to_f
    
    #x = (xp*w).to_i
   # y = (yp*h).to_i
#print "(x,y)=",x, " ",y,"\n"
    #FIXME2: test bordure extreme
    #if $host[ip].x + $host[ip].button.window.geometry[2] >= w # we cant see it
    #  $host[ip].x = w - $host[ip].button.window.geometry[2]
    #end
    #if $host[ip].y + $host[ip].button.window.geometry[3] >= h # we cant see it
    #  $host[ip].y = h - $host[ip].button.window.geometry[3]
    #end
	  
   # $host[ip].node_view.move(x-$host[ip].x,y-$host[ip].y)
  #}

end


private
def map_window_activ_full 
  if $win !=nil
    w=Gdk::screen_width
    h=Gdk::screen_height-30
    $win.window.resize(w,h)
    #proportional_node_position(w,h)
  end
end
private
def map_window_activ_half
  if $win !=nil
    w=Gdk::screen_width*2/3
    h=Gdk::screen_height*2/3
  	 root_width=$win.window.geometry[2]
  	 root_height=$win.window.geometry[3]
    $win.window.resize(w,h)
    proportional_node_position(root_width,root_height,w,h)
  end
end
private
def map_window_activ_quart
  if $win !=nil
    w=Gdk::screen_width/2
    h=Gdk::screen_height/2
  	 root_width=$win.window.geometry[2]
  	 root_height=$win.window.geometry[3]
    $win.window.resize(w,h)
    proportional_node_position(root_width,root_height,w,h)
  end
####################################################################################################
end

  private
  def new_map()
	 #stop all threads
	 #save()
    init_map()
  end

  public
  def quit_now()
	if !confirm_exit_window()
		$win.destroy()
	end
  end

  public
  def quit_all
    write_xml()
 	 $config.save_config()
	 $threads.list.each {|thr|
		Thread.kill(thr)
	 }
	 Gtk.main_quit
	 Syslog.close
  end

  public
  def window_close
    destroy
  end

  private
  def create_config_option
  	$config.show()
  end

  private
  def create_help
    help_window()  
  end

  private
  def create_about

   about = Gnome::About.new(PROJECTNAME, GNMSVERSION ,
                             "GPL",
                             "GNMS stands for Gnome Network Management System, is a tool for monitoring IP elements.",
                             AUTHORS,
			     					  DOCUMENTORS,
                             nil);
    about.show
  end
	
  private
  def open_file()
	fs=Gtk::FileChooserDialog.new("Open File",
                                     self,
                                     Gtk::FileChooser::ACTION_OPEN,
                                     nil,
                                     [Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL],
                                     [Gtk::Stock::OPEN, Gtk::Dialog::RESPONSE_ACCEPT]
											)
	if fs.run == Gtk::Dialog::RESPONSE_ACCEPT
		  init_map()
   	  $event_win.add_event("core", "INFO", iplocal()[0].split("/")[0], "Load #{fs.filename}")
   	  $win.set_title("Gnms -> Load #{fs.filename}")
   	  read_xml(fs.filename)
	end
	fs.destroy
  end

  private
  def save_file()
	save_to_filename=nil
	fs=Gtk::FileChooserDialog.new("Save as File",
                                     self,
                                     Gtk::FileChooser::ACTION_SAVE,
                                     nil,
                                     [Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL],
                                     [Gtk::Stock::SAVE, Gtk::Dialog::RESPONSE_ACCEPT]
											)
	if fs.run == Gtk::Dialog::RESPONSE_ACCEPT
		save_to_filename=fs.filename
	end
	fs.destroy
	return save_to_filename
  end

	private
	def save_as
		save_to_filename=save_file()
		if save_to_filename != nil
		   write_xml(save_to_filename)
		end
	end	
	private
	def save()
      write_xml()
	end

	def snapshot()
		def snapshot_file()
			i=1
			while (FileTest.exist?("snapshots/snapshot-#{i}.png"))
				i+=1
			end
			return "snapshots/snapshot-#{i}.png"
		end
		win=Gtk::Window.new
		win.set_title "Take a snapshot"
		ok_button=Gtk::Button.new("Snap it as #{snapshot_file()}")
		win.add ok_button
		win.show_all
		win.signal_connect("key_press_event") {|w,e|
   	  if e.keyval == Gdk::Keyval::GDK_Escape
      	 win.destroy
   	  end
		}

		ok_button.signal_connect("clicked") {
		x, y, width, height, depth = $canvas.window.geometry()
     		pixbuf = Gdk::Pixbuf.from_drawable(Gdk::Colormap.system, 
                                        $canvas.window, 0, 0, 
                                        width, height)
         pixbuf.save(snapshot_file(), "png") unless pixbuf == nil
			ok_button.set_label("Snap it as #{snapshot_file()}")
		}
	end
 
  def init_map()
	set_map()
	$network.each_key {|ip|
		if ip != ROOTMAPADDR
			$network[ip].delete()
		end
	}
   $host.each_key {|ip|
     $host[ip].delete()
   }
  end
end
