require 'gtk2'

module Gtk
  class CList < TreeView
	 attr_accessor :nb_event

	def set_sort_column(col_src,col_dst)
		get_column(col_src-1).set_sort_column_id(col_dst)
	end
    def initialize(ttitle)
     @nb_event=0
      super(Gtk::ListStore.new(Gdk::Color, *ttitle.collect{|d| d.class}))
      i=1
		renderer=Gtk::CellRendererText.new()
		#renderer.background = "pink"
      ttitle.each {|col|
		column=Gtk::TreeViewColumn.new(col, 
                              	renderer,{
                                 	 :background_gdk => 0,
                                 	 :text => i
											  })
		column.set_sort_column_id(i)
		append_column(column)
		i+=1
      }
    end

    def append(ttext)
      row=model.append
		set_bg_color(ttext[1], row)
		i=1
		ttext.each {|val|
	      row[i]=val
			i+=1
		}
		@nb_event+=1
    end

    def prepend(ttext)
		row=model.prepend
		set_bg_color(ttext[1], row)
		i=1
		ttext.each {|val|
			row[i]=val
			i+=1
		}
		@nb_event+=1		
    end

    def remove(row)
		if model.remove(row)
			@nb_event-=1
		end
	 end

    def clear()
		model.clear()
		@nb_event=0
    end

	 def get_value(iter, column)
			model.get_value(iter, column) unless iter == nil
	 end

	#
	#	change title of each column
	#
	def changed_all_column_name(table)
		indx=0
		columns.each do |col|
			col.set_title(table[indx])
			indx+=1
		end
	end

	#
	#	change title to str of column col 
	#
	def changed_column_name(col,str)
		get_column(col).set_title(str) unless col > (columns.size - 1)
	end


	private
	def set_bg_color(val, row)
		case val
		when ""
		when "PANIC"
			row[0]=$red
		when "ALERT"
			row[0]=$orange
		when "ERR"
			row[0]=$yellow
		when "WARN"
			row[0]=$blue
		when "INFO"
			row[0]=$green
		else
			#perhaps it s not a level it s a status ?
			set_bg_color(get_level_from_status(val),row)
		end
	end
  end
end

#list.signal_connect("cursor-changed") { |s, event|
#	puts "here #{event} #{s}"
#}
