class ConfigWindow

	def initialize(cfg)
		@config=cfg
	end


#
#	save configuration file
#
def save_config()

  fic=Tempfile.new(File.basename(GLOBAL_CONF_FILE))
  fic.puts("[GENERAL]")
	 fic.puts("#{get_map_width()}")
	 fic.puts("#{get_map_height()}")
	 fic.puts("#{$map}")
	 fic.puts("#{$config.host_label_view}")
	 fic.puts("#{$config.host_icon_view}")
	 fic.puts("#{$config.network_label_view}")
	 fic.puts("#{$config.network_icon_view}")
    fic.puts("#{$config.map_display_view}")

    fic.puts("#{@button_show_label.active?}")
    fic.puts("#{@button_noshow_fqdn.active?}")
    fic.puts("#{@button_show_tooltips.active?}")
    fic.puts("#{@button_confirm_delete.active?}")
    fic.puts("#{@button_confirm_quit.active?}")
    fic.puts("#{@combo_log_level.entry.text}")

  fic.puts("[SNMP]")
    fic.puts("#{@entry_read_community.text}")
    fic.puts("#{@entry_write_community.text}")
    fic.puts("#{@entry_snmp_version.text}")
    fic.puts("#{@port_spinner.value_as_int}")
    fic.puts("#{@timeout_spinner.value_as_int}")
    fic.puts("#{@retry_spinner.value_as_int}")

  fic.puts("[ADMIN]")
    fic.puts("#{@entry_mail.text}")
    fic.puts("#{@entry_level.entry.text}")
    for l in $LEVEL
      for typ in 0..$talert_type.size - 1
        fic.write("#{$level_alert_type[l][typ]},")
      end
      fic.puts
    end    
  fic.puts("[SCAN]")
    fic.puts("#{@button_bp.active?}")
    fic.puts("#{@entry_delay_bp.text}")
    fic.puts("#{@button_macf.active?}")
    fic.puts("#{@entry_delay_macf.text}")
    fic.puts("#{@button_macl.active?}")
    fic.puts("#{@button_macm.active?}")
    fic.puts("#{@button_nr.active?}")
    fic.puts("#{@entry_delay_nr.text}")
    fic.puts("#{@button_pm.active?}")
    fic.puts("#{@entry_delay_pm.text}")
    fic.puts("#{@button_snmp.active?}")
    fic.puts("#{@button_custom.active?}")
    fic.puts("#{@button_syslog_daemon.active?}")
    fic.puts("#{@entry_syslog_daemon_port.text}")

  fic.puts("[PATH]")
    fic.puts("#{@entry_ping.text}")
    fic.puts("#{@entry_ip.text}")
    fic.puts("#{@entry_nmap.text}")
    fic.puts("#{@entry_snmpget.text}")
    fic.puts("#{@entry_ssh.text}")
    fic.puts("#{@entry_telnet.text}")
    fic.puts("#{@entry_browser.text}")
    fic.puts("#{@entry_vncviewer.text}")
    fic.puts("#{@entry_rdesktop.text}")
    fic.puts("#{@entry_xterm.text}")
    fic.puts("#{@entry_nmblookup.text}")
    fic.puts("#{@entry_xprobe.text}")

  fic.puts("[KEYS]")
  
  fic.puts("[COLORS]")
    fic.puts("#{@entry_pixmap_size.text}")
	 if @colorchk.active?
  		fic.puts("color")
	 else
	  	fic.puts("image")
	 end
	 color_table=@cp.color.to_a()
    fic.puts("#{color_table[0]}")
    fic.puts("#{color_table[1]}")
    fic.puts("#{color_table[2]}")
	 fic.puts("#{@entry_image.filename}")

  fic.close()
  #all seems good

  File.rename(fic.path, GLOBAL_CONF_FILE)
  $log.info("Configuration file saved as #{GLOBAL_CONF_FILE}")
  @config.read_config()
end


def show()
  
window = Gtk::Window.new(Gtk::Window::TOPLEVEL)
window.set_title("Preference")
window.set_size_request(380,465)
window.border_width=0
window.set_modal true
#FIXME2
#put again
#window.set_allow_shrink true
#window.set_allow_grow false
window.signal_connect("key_press_event") {|w,e|
  if e.keyval == Gdk::Keyval::GDK_Escape
    if FileTest.exist?(GLOBAL_CONF_FILE)
      window.destroy
    end
  end
}

box1 = Gtk::VBox.new(FALSE, 0)
window.add(box1)
box1.show

box2 = Gtk::VBox.new(FALSE, 10)
box2.border_width=10
box1.pack_start(box2, TRUE, TRUE, 0)
box2.show

notebook = Gtk::Notebook.new()
notebook.set_tab_pos(Gtk::POS_TOP)
box2.pack_start(notebook, TRUE, TRUE, 0)
notebook.show

#onglet 0
  frame = Gtk::Frame::new("Overview")
  frame.border_width=10
  frame.set_size_request(200, 150)
  frame.show

  table = Gtk::Table.new(6,2,false)
  table.show
  frame.add table  

  @button_show_label = Gtk::CheckButton.new "Display label"
  @button_show_label.set_size_request 10,-1

  @button_show_label.set_active to_b(@config.show_label)
  @button_show_label.show
  table.attach(@button_show_label,0,1,1,2)
  @button_noshow_fqdn = Gtk::CheckButton.new "Display hostname instead of FQDN"
  @button_noshow_fqdn.set_size_request 10,-1
  @button_noshow_fqdn.set_active to_b(@config.noshow_fqdn)
  @button_noshow_fqdn.show
  table.attach(@button_noshow_fqdn,0,1,2,3)

  @button_show_tooltips = Gtk::CheckButton.new "Display node tooltips"
  @button_show_tooltips.set_size_request 10,-1
  @button_show_tooltips.set_active to_b(@config.show_tooltips)
  @button_show_tooltips.show
  table.attach(@button_show_tooltips,0,1,3,4)

  @button_confirm_delete = Gtk::CheckButton.new "Confirm before removing node(s)"
  @button_confirm_delete.set_size_request 10,-1
  @button_confirm_delete.set_active to_b(@config.confirm_delete)
  @button_confirm_delete.show
  table.attach(@button_confirm_delete,0,1,4,5)

  @button_confirm_quit = Gtk::CheckButton.new "Confirm before quit"
  @button_confirm_quit.set_size_request 10,-1
  @button_confirm_quit.set_active to_b(@config.confirm_quit)
  @button_confirm_quit.show
  table.attach(@button_confirm_quit,0,1,5,6)

  label_log_level = Gtk::Label.new "Set log level to"
  @combo_log_level = Gtk::Combo.new
  @combo_log_level.entry.set_editable false
  @combo_log_level.set_popdown_strings(["Debug", "Info", "Warning", "Error"])
  @combo_log_level.entry.set_text(@config.log_level)

  hbox=Gtk::HBox.new()
  hbox.add label_log_level
  hbox.add @combo_log_level
  hbox.show_all
  table.attach(hbox,0,1,6,7)
 
  label = Gtk::Label::new(format("General", 2))
  notebook.append_page frame, label

#onglet 1

  frame = Gtk::Frame.new("Configuration")
  frame.border_width=10
  frame.set_size_request(300, 300)
  frame.show
  
  #read_community write_community version port timeout retry

  table = Gtk::Table.new(6,2,false)
  table.show
  frame.add table
  
  label_read_community = Gtk::Label.new "Read community"
  label_read_community.show
  @entry_read_community = Gtk::Entry.new
  if @config.read_community == "" || @config.read_community == nil
    @entry_read_community.set_text "public" 
  else
    @entry_read_community.set_text @config.read_community
  end
  @entry_read_community.set_size_request(100,-1)
  @entry_read_community.show
  bbox=Gtk::HButtonBox.new
  bbox.show

  bbox.add @entry_read_community

  table.attach(label_read_community,0,1,0,1)
  table.attach(bbox,1,2,0,1)

  label_write_community = Gtk::Label.new "Write community"
  label_write_community.show
  @entry_write_community = Gtk::Entry.new 
  if @config.write_community == "" || @config.write_community == nil
    @entry_write_community.set_text "public"
  else
    @entry_write_community.set_text @config.write_community
  end
  @entry_write_community.set_size_request(100,-1)
  @entry_write_community.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_write_community

  table.attach(label_write_community,0,1,1,2)
  table.attach(bbox,1,2,1,2)  
  
  label_snmp_version = Gtk::Label.new "SNMP version"
  label_snmp_version.show
  @entry_snmp_version = Gtk::Entry.new
  if @config.snmp_version == "" || @config.snmp_version == nil
    @entry_snmp_version.set_text "1"
  else
    @entry_snmp_version.set_text @config.snmp_version
  end
  @entry_snmp_version.set_editable false
  @entry_snmp_version.set_size_request(100,-1)
  @entry_snmp_version.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_snmp_version
  
  table.attach(label_snmp_version,0,1,2,3)
  table.attach(bbox,1,2,2,3)  
  
  label_snmp_port = Gtk::Label.new "Port"
  label_snmp_port.show
  if @config.snmp_port == "" || @config.snmp_port == nil
    adj = Gtk::Adjustment::new(161.0, 1.0, 3600.0, 1.0, 5.0, 0.0)
  else
    adj = Gtk::Adjustment::new(@config.snmp_port.to_f, 1.0, 3600.0, 1.0, 5.0, 0.0)
  end
  @port_spinner = Gtk::SpinButton::new(adj, 0, 0)
  @port_spinner.set_wrap(true)
  @port_spinner.show  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @port_spinner
  
  table.attach(label_snmp_port,0,1,3,4)
  table.attach(bbox,1,2,3,4)  
  
  label_snmp_timeout = Gtk::Label.new "Timeout"
  label_snmp_timeout.show
  if @config.snmp_timeout == "" || @config.snmp_timeout == nil
    adj = Gtk::Adjustment::new(300.0, 1.0, 3600.0, 1.0, 5.0, 0.0)
  else
    adj = Gtk::Adjustment::new(@config.snmp_timeout.to_f, 1.0, 3600.0, 1.0, 5.0, 0.0)
  end
  @timeout_spinner = Gtk::SpinButton::new(adj, 0, 0)
  @timeout_spinner.set_wrap(true)
  @timeout_spinner.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @timeout_spinner
  
  table.attach(label_snmp_timeout,0,1,4,5)
  table.attach(bbox,1,2,4,5) 
  
  label_snmp_retry = Gtk::Label.new "Retry"
  label_snmp_retry.show
  if @config.snmp_retry == "" || @config.snmp_retry == nil
    adj = Gtk::Adjustment::new(5.0, 1.0, 3600.0, 1.0, 5.0, 0.0)
  else
    adj = Gtk::Adjustment::new(@config.snmp_retry.to_f, 1.0, 3600.0, 1.0, 5.0, 0.0)
  end
  @retry_spinner = Gtk::SpinButton::new(adj, 0, 0)
  @retry_spinner.set_wrap(true)
  @retry_spinner.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @retry_spinner
  
  table.attach(label_snmp_retry,0,1,5,6)
  table.attach(bbox,1,2,5,6) 
  
  label = Gtk::Label::new("SNMP")
  notebook.append_page frame, label

#onglet 2
  frame = Gtk::Frame::new("Notification")
  frame.border_width=10
  frame.set_size_request(200, 150)
  frame.show
  
  table2 = Gtk::Table.new(3,2,false)
  table2.show
  frame.add table2
  
  label_mail = Gtk::Label.new "Mail"
  label_mail.show
  @entry_mail = Gtk::Entry.new
  @entry_mail.set_editable(true)
  if @config.mail == "" || @config.mail == nil
    @entry_mail.set_text "root"
  else
    @entry_mail.set_text @config.mail
  end
  @entry_mail.set_size_request(100,-1)
  @entry_mail.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.set_size_request(30,10)
  bbox.add @entry_mail

  table2.attach(label_mail,0,1,0,1)
  table2.attach(bbox,1,2,0,1)

  label_level = Gtk::Label.new "Level"
  label_level.show
  @entry_level = Gtk::Combo.new
  @entry_level.entry.set_editable false
  @entry_level.set_popdown_strings($LEVEL)
  if @config.level == "" || @config.level == nil
    @entry_level.entry.set_text("#{$LEVEL[0]}")
  else
    @entry_level.entry.set_text(@config.level)
  end
  @entry_level.show

  bbox=Gtk::VButtonBox.new
  bbox.show
  bbox.add @entry_level
   
  chbutton = []
  
  for alert_type in $talert_type
    pos=$talert_type.index(alert_type)
    cb_t=Gtk::CheckButton.new alert_type
    cb_t.set_active($level_alert_type[@entry_level.entry.text][pos])
    cb_t.show
    chbutton.push cb_t

    cb_t.signal_connect("clicked") {|s|
      pos=$talert_type.index(s.label)
      $level_alert_type[@entry_level.entry.text][pos] = s.active?
    }

	bbox.add cb_t
  end

  @entry_level.entry.signal_connect("changed") {
	if (@entry_level.entry.text != "")
	  i=0
	  #reload checkbox depending on level selected
	  for cb in chbutton
		  cb.set_active($level_alert_type[@entry_level.entry.text][i])
		  i+=1
	  end
	end
	
  }
  
  table2.attach(label_level,0,1,1,2)
  table2.attach(bbox,1,2,1,2)

  label = Gtk::Label::new(format("Alert", 2))
  notebook.append_page frame, label

#onglet 3
#active monitoring
  vbox_frame=Gtk::VBox.new
  vbox_frame.show
  frame = Gtk::Frame::new("Active")
  frame.border_width=10
  #frame.set_size_request(200, 150)
  frame.show
  vbox_frame.add frame
  table = Gtk::Table.new(4,2,false)
  table.show
  frame.add table

  @button_bp = Gtk::CheckButton.new "Broadcast Ping"
  @button_bp.set_size_request 10,-1
  @button_bp.set_active to_b(@config.broadcast_ping_state)
  @button_bp.show

  @entry_delay_bp = Gtk::Entry.new
  @entry_delay_bp.show
  @entry_delay_bp.set_size_request 5,-1
  if @config.broadcast_ping_delay == "" || @config.broadcast_ping_delay == nil
    @entry_delay_bp.set_text "300"
  else
    @entry_delay_bp.set_text @config.broadcast_ping_delay
  end
  @entry_delay_bp.set_sensitive @button_bp.active?

  @button_bp.signal_connect("toggled") {
    @entry_delay_bp.set_sensitive @button_bp.active?
  }

  table.attach(@button_bp,0,1,2,3)
  table.attach(@entry_delay_bp,1,2,2,3)

  @button_macf = Gtk::CheckButton.new "Find MAC address"
  @button_macf.set_active to_b(@config.mac_state)
  @button_macf.show

  @entry_delay_macf = Gtk::Entry.new
  @entry_delay_macf.show
  @entry_delay_macf.set_size_request 5,-1
  if @config.mac_delay == "" || @config.mac_delay == nil
    @entry_delay_macf.set_text "60"
  else
    @entry_delay_macf.set_text @config.mac_delay
  end
  @entry_delay_macf.set_sensitive @button_macf.active?


  table.attach(@button_macf,0,1,3,4)
  table.attach(@entry_delay_macf,1,2,3,4)

  @button_macl = Gtk::CheckButton.new "Lock MAC address"
  @button_macl.set_active to_b(@config.mac_lock)
  @button_macl.show

  table.attach(@button_macl,0,1,4,5)

	vbox_macm=Gtk::VBox.new

	 @button_macm = Gtk::CheckButton.new "Show manufacturer MAC address"
	 @button_macm.set_active to_b(@config.mac_manufacturer)
	 @button_macm.show
	vbox_macm.add @button_macm
	if !mac_manufacturer_list_exist?()	
	  @button_macm.set_active false
	  @button_macm.set_sensitive false
	  #put a download OUIs button
	  @button_macm_dl = Gtk::Button.new("Download MAC manufacturer")
		@button_macm_dl.signal_connect("clicked"){
			Thread.start {
				@button_macm_dl.label="Processing OUIs from IEEE"
				if get_mac_manufacturer_list() == 0
	  				@button_macm.set_sensitive(true)
	  				@button_macm.set_active to_b(@config.mac_manufacturer)
					@button_macm_dl.hide()
				else
					@button_macm_dl.label="Error when processing OUIs from IEEE"
				end
			}
		}
	  @button_macm_dl.show
		vbox_macm.add @button_macm_dl
	end
	vbox_macm.show
  table.attach(vbox_macm,0,1,5,6)

  @button_macf.signal_connect("toggled") {
    @entry_delay_macf.set_sensitive @button_macf.active?
    @button_macl.set_sensitive @button_macf.active?
    @button_macm.set_sensitive @button_macf.active? unless !mac_manufacturer_list_exist?()
  }

  @button_nr = Gtk::CheckButton.new "Node Resolving"
  @button_nr.set_active to_b(@config.node_resolving)
  @button_nr.show

  @entry_delay_nr = Gtk::Entry.new
  @entry_delay_nr.show
  @entry_delay_nr.set_size_request 5,-1
  if @config.node_resolving_delay == "" || @config.node_resolving_delay == nil
    @entry_delay_nr.set_text "120"
  else
    @entry_delay_nr.set_text @config.node_resolving_delay
  end
  @entry_delay_nr.set_sensitive @button_nr.active?

  @button_nr.signal_connect("toggled") {
    @entry_delay_nr.set_sensitive @button_nr.active?
  }
  table.attach(@button_nr,0,1,6,7)
  table.attach(@entry_delay_nr,1,2,6,7)

  @button_pm = Gtk::CheckButton.new "Port Monitoring"
  if @config.nmap_path == ""
  	@button_pm.set_active false
  else
  	@button_pm.set_active to_b(@config.port_mon)
  end
  @button_pm.show

  @entry_delay_pm = Gtk::Entry.new
  @entry_delay_pm.show
  @entry_delay_pm.set_size_request 5,-1
  if @config.port_mon_delay == "" || @config.port_mon_delay == nil
    @entry_delay_pm.set_text "60"
  else
    @entry_delay_pm.set_text @config.port_mon_delay
  end
  @entry_delay_pm.set_sensitive @button_pm.active?

  @button_pm.signal_connect("toggled") {
  	if @config.nmap_path != ""
	    @entry_delay_pm.set_sensitive @button_pm.active?
	end
  }
  table.attach(@button_pm,0,1,8,9)
  table.attach(@entry_delay_pm,1,2,8,9)

  @button_snmp = Gtk::CheckButton.new "SNMP monitoring"
  @button_snmp.set_active to_b(@config.snmp_mon)
  @button_snmp.show

  table.attach(@button_snmp,0,1,9,10)

  @button_custom = Gtk::CheckButton.new "Custom monitoring"
  @button_custom.set_active to_b(@config.custom_mon)
  @button_custom.show

  table.attach(@button_custom,0,1,10,11)

#passive monitoring

  frame_passive = Gtk::Frame::new("Passive")
  frame_passive.border_width=10
  #frame_passive.set_size_request(200, 150)
  frame_passive.show
  vbox_frame.add frame_passive
  table_passive = Gtk::Table.new(1,2,false)
  table_passive.show
  frame_passive.add table_passive
  @button_syslog_daemon = Gtk::CheckButton.new "Syslog daemon port"
  @button_syslog_daemon.set_active to_b(@config.syslog_mon)
  @button_syslog_daemon.show

  @entry_syslog_daemon_port = Gtk::Entry.new
  @entry_syslog_daemon_port.show
  @entry_syslog_daemon_port.set_size_request 5,-1
  if @config.syslog_port == "" || @config.syslog_port == nil
    @entry_syslog_daemon_port.set_text "514"
  else
    @entry_syslog_daemon_port.set_text @config.syslog_port
  end
  @entry_syslog_daemon_port.set_sensitive @button_syslog_daemon.active?

  @button_syslog_daemon.signal_connect("toggled") {
    @entry_syslog_daemon_port.set_sensitive @button_syslog_daemon.active?
  }

  table_passive.attach(@button_syslog_daemon,0,1,0,1)
  table_passive.attach(@entry_syslog_daemon_port,1,2,0,1)

  label = Gtk::Label::new(format("Monitor", 2))
  notebook.append_page vbox_frame, label

#onglet 4 - need to be coded !
#  
#  frame = Gtk::Frame::new("Where to store nodes")
#  frame.border_width=10
#  frame.set_size_request(200, 150)
#  frame.show
#
#  vbox = Gtk::VButtonBox.new
#  vbox.show
#  frame.add vbox
#  cbfile = Gtk::CheckButton.new("In file, support for 1 network")
#  cbfile.show
#  vbox.add cbfile
#  cbdb = Gtk::CheckButton.new("In DB, support for many networks/subnetworks")
#  cbdb.show
#  vbox.add cbdb
#    
#  label = Gtk::Label::new(format("Database", 2))
#  notebook.append_page frame, label
#
#onglet 5
  frame = Gtk::Frame::new("Executable File Path")
  frame.border_width=10
  frame.set_size_request(200, 150)
  frame.show

  table = Gtk::Table.new(5,2,false)
  table.show
  frame.add table

  label_ping = Gtk::Label.new "ping"
  label_ping.show
  @entry_ping = Gtk::Entry.new 
  if @config.ping_path == "" || @config.ping_path == nil
    ou=`/usr/bin/which ping | /bin/grep \/`
    @entry_ping.set_text ou.chomp
  else
    @entry_ping.set_text @config.ping_path
  end
  @entry_ping.set_size_request(140,-1)
  @entry_ping.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_ping

  table.attach(label_ping,0,1,0,1)
  table.attach(bbox,1,2,0,1)  

  label_ip = Gtk::Label.new "ip"
  label_ip.show
  @entry_ip = Gtk::Entry.new 
  if @config.ip_path == "" || @config.ip_path == nil
    ou=`/usr/bin/which ip | /bin/grep \/`
    @entry_ip.set_text ou.chomp
  else
    @entry_ip.set_text @config.ip_path
  end
  @entry_ip.set_size_request(140,-1)
  @entry_ip.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_ip

  table.attach(label_ip,0,1,1,2)
  table.attach(bbox,1,2,1,2) 

  label_nmap = Gtk::Label.new "nmap"
  label_nmap.show
  @entry_nmap = Gtk::Entry.new
  
  if @config.nmap_path == "" || @config.nmap_path == nil
    ou=`/usr/bin/which nmap | /bin/grep \/`
    @entry_nmap.set_text ou.chomp
  else
    @entry_nmap.set_text @config.nmap_path
  end
  @entry_nmap.set_size_request(140,-1)
  @entry_nmap.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_nmap

  table.attach(label_nmap,0,1,2,3)
  table.attach(bbox,1,2,2,3) 

  label_snmpget = Gtk::Label.new "snmpget"
  label_snmpget.show
  @entry_snmpget = Gtk::Entry.new

  if @config.snmpget_path == "" || @config.snmpget_path == nil
    ou=`/usr/bin/which snmpget | /bin/grep \/`
    @entry_snmpget.set_text ou.chomp
  else
    @entry_snmpget.set_text @config.snmpget_path
  end
  @entry_snmpget.set_size_request(140,-1)
  @entry_snmpget.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_snmpget

  table.attach(label_snmpget,0,1,3,4)
  table.attach(bbox,1,2,3,4) 

  label_ssh = Gtk::Label.new "ssh"
  label_ssh.show
  @entry_ssh = Gtk::Entry.new

  if @config.ssh_path == "" || @config.ssh_path == nil
    ou=`/usr/bin/which ssh | /bin/grep \/`
    @entry_ssh.set_text ou.chomp
  else
    @entry_ssh.set_text @config.ssh_path
  end
  @entry_ssh.set_size_request(140,-1)
  @entry_ssh.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_ssh

  table.attach(label_ssh,0,1,4,5)
  table.attach(bbox,1,2,4,5) 

  label_telnet = Gtk::Label.new "telnet"
  label_telnet.show
  @entry_telnet = Gtk::Entry.new

  if @config.telnet_path == "" || @config.telnet_path == nil
    ou=`/usr/bin/which telnet | /bin/grep \/`
    @entry_telnet.set_text ou.chomp
  else
    @entry_telnet.set_text @config.telnet_path
  end
  @entry_telnet.set_size_request(140,-1)
  @entry_telnet.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_telnet

  table.attach(label_telnet,0,1,5,6)
  table.attach(bbox,1,2,5,6)
  
  label_browser = Gtk::Label.new "browser"
  label_browser.show
  @entry_browser = Gtk::Entry.new

  if @config.browser_path == "" || @config.browser_path == nil
    for br in ["firefox", "mozilla", "netscape", "konqueror", "galeon"]
      ou=`/usr/bin/which #{br} | /bin/grep \/`
      if ou != ""
        break
      end
    end
    @entry_browser.set_text ou.chomp
  else
    @entry_browser.set_text @config.browser_path
  end
  @entry_browser.set_size_request(140,-1)
  @entry_browser.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_browser

  table.attach(label_browser,0,1,6,7)
  table.attach(bbox,1,2,6,7)
  
  label_vncviewer = Gtk::Label.new "VNC client"
  label_vncviewer.show
  @entry_vncviewer = Gtk::Entry.new

  if @config.vncviewer_path == "" || @config.vncviewer_path == nil
    ou=`/usr/bin/which vncviewer | /bin/grep \/`
    @entry_vncviewer.set_text ou.chomp
  else
    @entry_vncviewer.set_text @config.vncviewer_path
  end
  @entry_vncviewer.set_size_request(140,-1)
  @entry_vncviewer.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_vncviewer

  table.attach(label_vncviewer,0,1,7,8)
  table.attach(bbox,1,2,7,8) 

  label_rdesktop = Gtk::Label.new "RDP client"
  label_rdesktop.show
  @entry_rdesktop = Gtk::Entry.new

  if @config.rdesktop_path == "" || @config.rdesktop_path == nil
    ou=`/usr/bin/which rdesktop | /bin/grep \/`
    @entry_rdesktop.set_text ou.chomp
  else
    @entry_rdesktop.set_text @config.rdesktop_path
  end
  @entry_rdesktop.set_size_request(140,-1)
  @entry_rdesktop.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_rdesktop

  table.attach(label_rdesktop,0,1,8,9)
  table.attach(bbox,1,2,8,9) 

  label_xterm = Gtk::Label.new "terminal launcher"
  label_xterm.show
  @entry_xterm = Gtk::Entry.new

  if @config.xterm_path == "" || @config.xterm_path == nil
    ou=`/usr/bin/which xterm | /bin/grep \/`
    if ou
      @entry_xterm.set_text "#{ou.chomp} -e "
    end
  else
    @entry_xterm.set_text @config.xterm_path
  end
  @entry_xterm.set_size_request(140,-1)
  @entry_xterm.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_xterm

  table.attach(label_xterm,0,1,9,10)
  table.attach(bbox,1,2,9,10) 

  label_nmblookup = Gtk::Label.new "nmblookup"
  label_nmblookup.show
  @entry_nmblookup = Gtk::Entry.new

  if @config.nmblookup_path == "" || @config.nmblookup_path == nil
    ou=`/usr/bin/which nmblookup | /bin/grep \/`
    @entry_nmblookup.set_text ou.chomp
  else
    @entry_nmblookup.set_text @config.nmblookup_path
  end
  @entry_nmblookup.set_size_request(140,-1)
  @entry_nmblookup.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_nmblookup

  table.attach(label_nmblookup,0,1,10,11)
  table.attach(bbox,1,2,10,11) 

  label_xprobe = Gtk::Label.new "xprobe2"
  label_xprobe.show
  @entry_xprobe = Gtk::Entry.new

  if @config.xprobe_path == "" || @config.xprobe_path == nil
    ou=`/usr/bin/which xprobe2 | /bin/grep \/`
    @entry_xprobe.set_text ou.chomp
  else
    @entry_xprobe.set_text @config.xprobe_path
  end
  @entry_xprobe.set_size_request(140,-1)
  @entry_xprobe.show
  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add @entry_xprobe

  table.attach(label_xprobe,0,1,11,12)
  table.attach(bbox,1,2,11,12) 

  #end path elf

  label = Gtk::Label::new(format("Path", 2))
  notebook.append_page frame, label

#onglet 6
  frame = Gtk::Frame::new("Accelerator")
  frame.border_width=10
  frame.set_size_request(200, 150)
  frame.show
  
	label = Gtk::Label.new("keys are not yet dynamic")
	label.show
	frame.add label
	
  label = Gtk::Label::new(format("Keys", 2))
  notebook.append_page frame, label

#onglet 7
  frame = Gtk::Frame::new("Default")
  frame.border_width=10
  frame.set_size_request(200, 150)
  frame.show

  vbox = Gtk::VButtonBox.new
  vbox.set_layout_style(Gtk::ButtonBox::SPREAD)
  vbox.show
  frame.add vbox
  
  hbox = Gtk::HButtonBox.new
  hbox.set_layout_style(Gtk::ButtonBox::SPREAD)
  hbox.show
  vbox.add hbox
  
  button_ps = Gtk::CheckButton.new "Resize node icon"
  button_ps.show
  hbox.add button_ps

  @entry_pixmap_size = Gtk::Entry.new
  @entry_pixmap_size.show
  @entry_pixmap_size.set_size_request 3,-1
  if @config.pixmap_size == "" || @config.pixmap_size == nil
    @entry_pixmap_size.set_text "35"
  else
    @entry_pixmap_size.set_text(@config.pixmap_size.to_s())
  end
  if @config.pixmap_size == "0"
    button_ps.set_active false
  else
    button_ps.set_active true
  end
  @entry_pixmap_size.set_sensitive button_ps.active?

  button_ps.signal_connect("toggled") {
    if !button_ps.active?
      @entry_pixmap_size.set_sensitive false
      @entry_pixmap_size.set_text "0"
    else
      @entry_pixmap_size.set_sensitive true
      @entry_pixmap_size.set_text(@config.pixmap_size.to_s())
    end
  }
  hbox.add @entry_pixmap_size
    
  @colorchk = Gtk::CheckButton.new("Color")
  @colorchk.show
  vbox.add @colorchk
    
  hbb=Gtk::HButtonBox.new
  hbb.set_layout_style(Gtk::ButtonBox::SPREAD)
  hbb.show

  @cp = Gtk::ColorButton.new
  @cp.set_use_alpha(false)
  if @config.bg_type != nil
  	if @config.bg_type == "color"
		@colorchk.set_active true
		@cp.set_sensitive true
	else
		@colorchk.set_active false
		@cp.set_sensitive false
	end
  end
  gdk_color=nil
  if @config.rgb == nil
		gdk_color=Gdk::Color.new(65535, 65535, 65535)
  else
		gdk_color=Gdk::Color.new(@config.rgb[0].to_f, @config.rgb[1].to_f, @config.rgb[2].to_f)
  end
  @cp.set_color(gdk_color)
  hbb.add @cp
  vbox.add hbb
  @cp.show
  
  imagechk = Gtk::CheckButton.new("Image")
  imagechk.show

  vbox.add imagechk

  hbb2=Gtk::HButtonBox.new
  hbb2.set_layout_style(Gtk::ButtonBox::SPREAD)
  hbb2.show

  @entry_image=Gnome::IconEntry.new("Foo","Icon")
  if @config.image_path[0,1] == '/'
    @entry_image.set_pixmap_subdir(@config.image_path)
    @entry_image.filename=@config.image_path
  else
    @entry_image.set_pixmap_subdir("#{PIXMAP_PATH}/bg")
    @entry_image.filename="#{PIXMAP_PATH}/bg/"
  end

  @entry_image.show
  hbb2.add @entry_image
  vbox.add hbb2
  if @config.bg_type != nil
	  if @config.bg_type == "image"
		imagechk.set_active(true)
	  	@entry_image.set_sensitive true
	  else
		imagechk.set_active(false)
		@entry_image.set_sensitive false
	  end
  end  
  
   @colorchk.signal_connect("toggled") {
		if @colorchk.active?
			@cp.set_sensitive(true)
			imagechk.set_active(false)
			@entry_image.set_sensitive(false)
		else
		  	@cp.set_sensitive(false)
			imagechk.set_active(true)
			@entry_image.set_sensitive(true)
		end

	}
   imagechk.signal_connect("clicked") {
		if imagechk.active?
		  	@entry_image.set_sensitive(true)
			@colorchk.set_active(false)
			@cp.set_sensitive(false)
		else
		  	@entry_image.set_sensitive(false)
			@colorchk.set_active(true)
			@cp.set_sensitive(true)
		end
  }
  
  label = Gtk::Label::new(format("Display", 2))
  notebook.append_page frame, label
#end

separator = Gtk::HSeparator::new()
box1.pack_start(separator, FALSE, TRUE, 0)
separator.show

box2 = Gtk::HBox::new(FALSE, 10)
box2.border_width=10
box1.pack_start(box2, FALSE, TRUE, 0)
box2.show

button = Gtk::Button::new("Ok")
button.signal_connect("clicked") do

  if $win != nil && ($network[get_map()].map_bg_type == nil)
  	if @colorchk.active? == true
		$canvas.unset_background_image()
		set_background_color(@cp.color())
    else
	 	if @entry_image.filename!=nil && (FileTest.exist?(@entry_image.filename))
		    $canvas.set_background_image(@entry_image.filename)
		else
		  print "Warning: Image background #{@entry_image.filename} doesnt exist !\n"
        #give focus to color
     	  	imagechk.set_active(false)
     	  	@colorchk.set_active(true)
         @config.bg_type="color"
		end
	end
	old_config_show_label=to_b(@config.show_label)
	old_config_noshow_fqdn=to_b(@config.noshow_fqdn)
	old_config_show_tooltips=to_b(@config.show_tooltips)
	old_config_log_level=@config.log_level
	old_config_pixmap_size=@config.pixmap_size

	#thread management
	old_port_mon=to_b(@config.port_mon)
	old_snmp_mon=to_b(@config.snmp_mon)
	old_custom_mon=to_b(@config.custom_mon)
	old_ping_state=to_b(@config.broadcast_ping_state)
	old_mac_state=to_b(@config.mac_state)
	old_node_resolving=to_b(@config.node_resolving)
	old_syslog_mon=to_b(@config.syslog_mon)

	save_config()

	if old_port_mon != @button_pm.active?
		if @button_pm.active?
			add_monitoring_thread("Port monitoring",tmonitorport())
		else
			del_monitoring_thread("Port monitoring")
		end
	end
	if old_snmp_mon != @button_snmp.active?
		if @button_snmp.active?
			add_monitoring_thread("Snmp monitoring",tmonitorsnmp())
		else
			del_monitoring_thread("Snmp monitoring")
		end
	end
	if old_custom_mon != @button_custom.active?
		if @button_custom.active?
			add_monitoring_thread("Custom monitoring",tmonitorcustom())
		else
			del_monitoring_thread("Custom monitoring")
		end
	end
	if old_ping_state != @button_bp.active?
		if @button_bp.active?
			add_monitoring_thread("Local ping",tfindlocalhost())
			add_monitoring_thread("Remote ping",t_find_remote_new_host())
		else
			del_monitoring_thread("Local ping")
			del_monitoring_thread("Remote ping")
		end
	end
	if old_mac_state != @button_macf.active?
		if @button_macf.active?
			add_monitoring_thread("Find mac",tmacip())
		else
			del_monitoring_thread("Find mac")
		end
	end
	if old_node_resolving != @button_nr.active?
		if @button_nr.active?
			add_monitoring_thread("Resolve ip to name",tresolvip())
			add_monitoring_thread("Resolve ip to netbios",tresolvnetbiosname())
			add_monitoring_thread("Find os",tresolvos())
		else
			del_monitoring_thread("Resolve ip to name")
			del_monitoring_thread("Resolve ip to netbios")
			del_monitoring_thread("Find os")
		end
	end

	if old_syslog_mon != @button_syslog_daemon.active?
		if  @button_syslog_daemon.active?
			$syslog_capture=SyslogCapture.new()
		else
			if $syslog_capture != nil
				$syslog_capture.stop()
			end
		end
	end

	if old_config_show_label != @button_show_label.active?
		#only remove label from node host
		$network[get_map()].host.each_value {|n|
			n.set_label_visibility()
		}
	end
	if old_config_noshow_fqdn != @button_noshow_fqdn.active?
		#only show fqdn on node host
		$network[get_map()].host.each_value {|n|
			if n.class == Host
				n.refresh_dns_name()
			end
		}
	end
	if old_config_log_level != @entry_level.entry.text
		$log.level=txtlvl_to_loggerlvl(@config.log_level)
	end
	if old_config_pixmap_size.to_i() != @entry_pixmap_size.text.to_i()
		$network[get_map()].host.each_value {|n|
				n.node_view.resize()
		}
	end

  end
  window.destroy
  #exit
end

box2.pack_start(button, TRUE, TRUE, 0)
button.set_flags(Gtk::Widget::CAN_DEFAULT);
button.grab_default
button.show

button = Gtk::Button::new("Cancel")
button.signal_connect("clicked") do
  if FileTest.exist?(GLOBAL_CONF_FILE)
    window.destroy
  end
end
box2.pack_start(button, TRUE, TRUE, 0)
button.set_flags(Gtk::Widget::CAN_DEFAULT);
button.grab_default
button.show

window.show

end

end
