require "#{GNMSLIB}"+'module/snmp_monitoring'
require "#{GNMSLIB}"+'module/syslog_monitoring'

class NodeHostProperty

def toggle_select_port(path=0)
    #switch all port
	 @treeview.model.each {|model, path, iter|
      fixed =iter[0]
      fixed ^= 1
      @cbutton[path.to_str().to_i()]=fixed
      iter[0] = fixed
	}
end

def toggle_select_custom(path=0)
	 @customview.model.each {|model, path, iter|
      fixed =iter[0]
      fixed ^= 1
      iter[0] = fixed
	}
end

def include_regex_str(str,list)
	list.each {|str_lign|
		if str_lign.match(str)
			return true
		end
	} unless list == nil
	return false
end

#
#	add or modify an existing service
#
	def add_monitored_service(mode=nil)

	 protocol=nil
	 port=nil
	 service_name=nil

    addportwin=Gtk::Window.new

	 if mode
		 if @treeview.selection.selected == nil
			return
		 end
		 title="Edit monitored service"
		 iter=@treeview.selection.selected
		 protocol=iter[1]
		 port=iter[2]
	    service_name=iter[3]
  	 else
		 title="Add monitored service"
    end

    addportwin.set_title(title)
    addportwin.set_size_request(315, 160)
    addportwin.set_modal(true)

    addportwin.signal_connect("key_press_event") {|w,e|
      if e.keyval == Gdk::Keyval::GDK_Escape
			addportwin.destroy
      end
    }

    frame = Gtk::Frame::new
    frame.border_width=10
    frame.show
    vbox_root=Gtk::VBox::new
    vbox_root.show
    addportwin.add vbox_root
    vbox_root.add frame
    vbox = Gtk::VBox.new
    vbox.show
    frame.add vbox

    table = Gtk::Table.new(3,2,false)
    table.show

	 entry_serv = Gtk::Entry.new
	 entry_serv.set_text(service_name) unless service_name==nil
    label_proto = Gtk::Label.new "Protocol"
    label_proto.show

  	 entry_proto = Gtk::Combo.new
  	 entry_proto.entry.set_editable false
 	 entry_proto.set_use_arrows true
 	 entry_proto.set_popdown_strings(["tcp","udp"])
	 entry_proto.entry.set_text(protocol) unless protocol==nil
	 entry_proto.set_size_request(20,-1)
	 entry_proto.show

	 bbox=Gtk::HButtonBox.new
	 bbox.show
	 bbox.add entry_proto
    table.attach(label_proto,0,1,0,1)
    table.attach(bbox,1,2,0,1)

	 label_port = Gtk::Label.new "Port"
	 label_port.show
	 entry_port = Gtk::Entry.new
	 entry_port.set_text(port.to_s()) unless port==nil
	 entry_port.set_size_request(20,-1)
	 entry_port.show
	 entry_port.signal_connect("changed") {
		 entry_serv.text=service_name(entry_proto.entry.text, entry_port.text)
	 }
	 entry_proto.entry.signal_connect("changed") {
		 entry_serv.text=service_name(entry_proto.entry.text, entry_port.text) unless entry_port.text==nil
	 }
	 bbox=Gtk::HButtonBox.new
	 bbox.show
	 bbox.add entry_port
    table.attach(label_port,0,1,1,2)
    table.attach(bbox,1,2,1,2)

	 label_serv = Gtk::Label.new "Service"
	 label_serv.show
	 entry_serv.set_size_request(20,-1)
	 entry_serv.show
	 bbox=Gtk::HButtonBox.new
	 bbox.show
	 bbox.add entry_serv
    table.attach(label_serv,0,1,2,3)
    table.attach(bbox,1,2,2,3)

    ok_button = Gtk::Button.new("Ok")
    ok_button.show
    ok_button.signal_connect("clicked") {
		if mode
			#here we just modify this service
			iter=@treeview.selection.selected
			iter[1] = entry_proto.entry.text
			iter[2] = entry_port.text.to_i
			iter[3] = entry_serv.text
     		addportwin.destroy()
		else
 		  #just add this service
   	  if isInteger(entry_port.text)
			  search_mon_port=false
			  @treeview.model.each {|model, path, iter|
				 if iter[2]==entry_port.text.to_i && iter[1]==entry_proto.entry.text
					 search_mon_port=true
					 break
				 end
			  }

			 if search_mon_port==false
				iter=@treeview.model.append
				iter[0] = 1
				iter[1] = entry_proto.entry.text
				iter[2] = entry_port.text.to_i
				iter[3] = entry_serv.text
      		addportwin.destroy()
			 else
				 errorEntry(addportwin, "#{entry_proto.entry.text}/#{entry_port.text} already exists")
			 end
   	  else 
  	   	  errorEntry(addportwin, entry_port.text)
   	  end
		end
    }

    cancel_button = Gtk::Button.new("Cancel")
    cancel_button.show
    cancel_button.signal_connect("clicked") {
  	    addportwin.destroy 
    }

	 bbox =Gtk::HBox::new(FALSE, 10)
	 bbox.border_width=10
	 bbox.show

	 ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(ok_button, TRUE, TRUE, 0)
	 cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(cancel_button, TRUE, TRUE, 0)

	 vbox.add(table)
	 separator = Gtk::HSeparator::new()
	 separator.show
	 vbox_root.pack_start(separator, FALSE, TRUE, 0)
	 vbox_root.pack_start(bbox, FALSE, TRUE, 0)

    addportwin.show
	
	end

def add_monitored_snmp(mode=nil)
	 oidref=nil
	 operator=nil
	 threshold=nil
	 severity=nil

    addsnmpwin=Gtk::Window.new

	 if mode
		 if @snmpview.selection.selected == nil
			return
		 end
		 title="Edit monitored SNMP OID"
		 iter=@snmpview.selection.selected
		 oidref=iter[0]
		 operator=iter[1]
	    threshold=iter[2]
	    severity=iter[3]
  	 else
		 title="Add monitored SNMP OID"
    end

    addsnmpwin.set_title(title)
    addsnmpwin.set_size_request(340, 190)
    addsnmpwin.set_modal(true)

    addsnmpwin.signal_connect("key_press_event") {|w,e|
      if e.keyval == Gdk::Keyval::GDK_Escape
			addsnmpwin.destroy
      end
    }

    frame = Gtk::Frame::new
    frame.border_width=10
    frame.show
    vbox_root=Gtk::VBox::new
    vbox_root.show
    addsnmpwin.add vbox_root
    vbox_root.add frame
    vbox = Gtk::VBox.new
    vbox.show
    frame.add vbox

    table = Gtk::Table.new(4,2,false)
    table.show

	 label_oidref = Gtk::Label.new "OID Ref"
    label_oidref.show
  	 entry_oidref = Gtk::Combo.new
  	 entry_oidref.entry.set_editable false
 	 entry_oidref.set_use_arrows true
 	 entry_oidref.set_popdown_strings(get_oid_refs_name())
	 entry_oidref.entry.set_text(oidref) unless oidref==nil
	 entry_oidref.set_size_request(150,-1)
	 entry_oidref.show
	 bbox=Gtk::HButtonBox.new
	 bbox.show
	 bbox.add entry_oidref
    table.attach(label_oidref,0,1,0,1)
    table.attach(bbox,1,2,0,1)

	 label_operator = Gtk::Label.new "Operator"
    label_operator.show
  	 entry_operator = Gtk::Combo.new
  	 entry_operator.entry.set_editable false
 	 entry_operator.set_use_arrows true
 	 entry_operator.set_popdown_strings(SnmpMonitoring::TESTOP)
	 entry_operator.entry.set_text(operator) unless operator==nil
	 entry_operator.set_size_request(150,-1)
	 entry_operator.show
	 bbox=Gtk::HButtonBox.new
	 bbox.show
	 bbox.add entry_operator
    table.attach(label_operator,0,1,1,2)
    table.attach(bbox,1,2,1,2)

	 entry_threshold = Gtk::Entry.new
	 entry_threshold.set_text(threshold) unless threshold==nil
    label_threshold = Gtk::Label.new "Threshold"
	 label_threshold.show
	 entry_threshold.set_size_request(150,-1)
	 entry_threshold.show
	 bbox=Gtk::HButtonBox.new
	 bbox.show
	 bbox.add entry_threshold
    table.attach(label_threshold,0,1,2,3)
    table.attach(bbox,1,2,2,3)

	 label_sev = Gtk::Label.new "Severity"
    label_sev.show
  	 entry_sev = Gtk::Combo.new
  	 entry_sev.entry.set_editable false
 	 entry_sev.set_use_arrows true
 	 entry_sev.set_popdown_strings($status[0..3])
	 entry_sev.entry.set_text(severity) unless severity==nil
	 entry_sev.set_size_request(150,-1)
	 entry_sev.show
	 bbox=Gtk::HButtonBox.new
	 bbox.show
	 bbox.add entry_sev
    table.attach(label_sev,0,1,3,4)
    table.attach(bbox,1,2,3,4)

    ok_button = Gtk::Button.new("Ok")
    ok_button.show
    ok_button.signal_connect("clicked") {
		if mode
			#here we just modify this service
			iter=@snmpview.selection.selected
			iter[0] = entry_oidref.entry.text
			iter[1] = entry_operator.entry.text
			iter[2] = entry_threshold.text
			iter[3] = entry_sev.entry.text
     		addsnmpwin.destroy()
		else
				#need to verify 
				#if search_mon_oidref==false
			if isInteger(entry_threshold.text)
					iter=@snmpview.model.append
					iter[0] = entry_oidref.entry.text
					iter[1] = entry_operator.entry.text
					iter[2] = entry_threshold.text
					iter[3] = entry_sev.entry.text
      			addsnmpwin.destroy()
			else
				 errorEntry(addsnmpwin, "Threshold #{entry_threshold.text} need to be an integer")
			end
		end
    }

    cancel_button = Gtk::Button.new("Cancel")
    cancel_button.show
    cancel_button.signal_connect("clicked") {
  	    addsnmpwin.destroy 
    }

	 bbox =Gtk::HBox::new(FALSE, 10)
	 bbox.border_width=10
	 bbox.show

	 ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(ok_button, TRUE, TRUE, 0)
	 cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(cancel_button, TRUE, TRUE, 0)

	 vbox.add(table)
	 separator = Gtk::HSeparator::new()
	 separator.show
	 vbox_root.pack_start(separator, FALSE, TRUE, 0)
	 vbox_root.pack_start(bbox, FALSE, TRUE, 0)

    addsnmpwin.show
end

def add_monitored_syslog(mode=nil)
	 snmpref=nil
	 severity=nil

    addsyslogwin=Gtk::Window.new

	 if mode
		 if @syslogview.selection.selected == nil
			return
		 end
		 title="Edit monitored Syslog Ref"
		 iter=@syslogview.selection.selected
		 snmpref=iter[0]
		 severity=iter[1]
  	 else
		 title="Add monitored Syslog Ref"
    end

    addsyslogwin.set_title(title)
    addsyslogwin.set_size_request(340, 190)
    addsyslogwin.set_modal(true)

    addsyslogwin.signal_connect("key_press_event") {|w,e|
      if e.keyval == Gdk::Keyval::GDK_Escape
			addsyslogwin.destroy
      end
    }

    frame = Gtk::Frame::new
    frame.border_width=10
    frame.show
    vbox_root=Gtk::VBox::new
    vbox_root.show
    addsyslogwin.add vbox_root
    vbox_root.add frame
    vbox = Gtk::VBox.new
    vbox.show
    frame.add vbox

    table = Gtk::Table.new(4,2,false)
    table.show

	 label_oidref = Gtk::Label.new "Syslog Ref"
    label_oidref.show
  	 entry_oidref = Gtk::Combo.new
  	 entry_oidref.entry.set_editable false
 	 entry_oidref.set_use_arrows true
 	 entry_oidref.set_popdown_strings(get_syslog_refs_name())
	 entry_oidref.entry.set_text(snmpref) unless snmpref==nil
	 entry_oidref.set_size_request(150,-1)
	 entry_oidref.show
	 bbox=Gtk::HButtonBox.new
	 bbox.show
	 bbox.add entry_oidref
    table.attach(label_oidref,0,1,0,1)
    table.attach(bbox,1,2,0,1)

	 label_sev = Gtk::Label.new "Severity"
    label_sev.show
  	 entry_sev = Gtk::Combo.new
  	 entry_sev.entry.set_editable false
 	 entry_sev.set_use_arrows true
 	 entry_sev.set_popdown_strings($status[0..3])
	 entry_sev.entry.set_text(severity) unless severity==nil
	 entry_sev.set_size_request(150,-1)
	 entry_sev.show
	 bbox=Gtk::HButtonBox.new
	 bbox.show
	 bbox.add entry_sev
    table.attach(label_sev,0,1,1,2)
    table.attach(bbox,1,2,1,2)

    ok_button = Gtk::Button.new("Ok")
    ok_button.show
    ok_button.signal_connect("clicked") {
		iter=nil
		if mode
			#here we just modify this service
			iter=@syslogview.selection.selected
		else
			iter=@syslogview.model.append
		end
		iter[0] = entry_oidref.entry.text
		iter[1] = entry_sev.entry.text
     	addsyslogwin.destroy()
    }

    cancel_button = Gtk::Button.new("Cancel")
    cancel_button.show
    cancel_button.signal_connect("clicked") {
  	    addsyslogwin.destroy 
    }

	 bbox =Gtk::HBox::new(FALSE, 10)
	 bbox.border_width=10
	 bbox.show

	 ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(ok_button, TRUE, TRUE, 0)
	 cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(cancel_button, TRUE, TRUE, 0)

	 vbox.add(table)
	 separator = Gtk::HSeparator::new()
	 separator.show
	 vbox_root.pack_start(separator, FALSE, TRUE, 0)
	 vbox_root.pack_start(bbox, FALSE, TRUE, 0)

    addsyslogwin.show
end

def edit_monitored_service()
	add_monitored_service("edit")
end

def edit_monitored_snmp()
	add_monitored_snmp("edit")
end

def edit_monitored_syslog()
	add_monitored_syslog("edit")
end

def fill_port_view(node)
	@treeview.show
	@vbox_ports.add(@treeview)
	 row_mon_port=[]
	 if @scanned_port_list != nil
   	for x in 1..@scanned_port_list.size
		  row=[]
		  plattr=@scanned_port_list[x-1].split(/[\ ]+/)
		  port=plattr[0].to_i()
		  proto=plattr[1]
		  name=plattr[2]

		  #we verify if we monitor this port
		  cbutton=0
		  if monitor_host_port(node.service,proto,port)				
			  cbutton=1
		  end
		  if name == ""
			  service = "?"
		  else
			  service = name
		  end
		  @cbutton.push(cbutton)
		  row.push(cbutton)			
		  row.push(proto)
		  row.push(port)
		  row.push(service)
		  row_mon_port.push(row)
	  end
	end
   row_mon_port.each do |cb, proto, port, service|
	  iter = @treeview.model.append
	  iter[0] = cb
	  iter[1] = proto
	  iter[2] = port
	  iter[3] = service
	end
end



def fill_port_list(node)

	#we need to append all monitored ports of service hash
	#@scanned_port_list is ordered as udp first and port number ...
	if node.service != nil
     if @scanned_port_list == nil
		  @scanned_port_list=[]
		  node.service.sort{|s1,s2| s1[0].split('/')[1].to_i()<=>s2[0].split('/')[1].to_i()}.each {|w,serv|
       	  str="#{serv.port} #{serv.protocol} "
			  @scanned_port_list.push "#{str} #{serv.name}"
		  }
	  else
   	 node.service.each_value {|serv|
      	str="#{serv.port} #{serv.protocol} "
      	if !include_regex_str("^#{str}",@scanned_port_list)
      	  # we need to add it correctly
			  plistbis=[]
      	  i=0
      	  for pt in @scanned_port_list
         	 ptt = pt.split(/ /)
         	 if ptt[1] == serv.protocol && serv.port.to_i < ptt[0].to_i
            	plistbis.push "#{str} #{serv.name}"
            	for port in @scanned_port_list[i..@scanned_port_list.size-1]
            	  plistbis.push port
            	end
            	break
         	 else
            	if ptt[1] != serv.protocol
            	  if serv.protocol == "udp"           
	            	 plistbis.push "#{str} #{serv.name}"
               	 for port in @scanned_port_list[i..@scanned_port_list.size-1]
                  	plistbis.push port
               	 end
               	 break
            	  else #its ptt[1] udp the first
               	 plistbis.push pt
            	  end
            	else
            	  plistbis.push pt
            	end
         	 end
         	 i+=1
      	  end
      	  @scanned_port_list=plistbis
		  end
			}
	  end
	end
end

def scan_port_now(node)
    
	@scan_port_th=Thread.new {
	labelwait=Gtk::Label.new("Waiting scanning ports ...")
	labelwait.show
	@treeview.hide
	@vbox_ports.remove(@treeview)
	@treeview.model.clear()
	@vbox_ports.add(labelwait)
	@scanned_port_list=listport(node.ip).split(/\n/)
	fill_port_list(node)
	labelwait.hide
	@vbox_ports.remove(labelwait)
	labelwait.destroy
	fill_port_view(node)
 }
end


###############################################################
  def initialize (node)

  #$savedport=node.service
	
  window=Gtk::Window.new
  window.set_transient_for($win)
  window.set_title("Property of "+node.ip)
  window.set_size_request(400, 400)
  window.set_modal(true)
  vboxb = Gtk::VBox::new
  window.add vboxb
  vboxb.show	

  #FIXME2
  #window.set_policy true,false,true
  window.signal_connect("key_press_event") {|w,e|
    if e.keyval == Gdk::Keyval::GDK_Escape
      window.destroy
    end
  }

  notebook = Gtk::Notebook::new()
  notebook.set_tab_pos(Gtk::POS_TOP)
  vboxb.add notebook
  notebook.show

################################ status tab #########

  frame = Gtk::Frame::new
  frame.border_width=10
  frame.set_size_request(300, 290)
  frame.show

  vbox = Gtk::VBox::new(false,2)
  vbox.show
  frame.add vbox 

  table_st = Gtk::Table.new(1,2,false)
  table_st.show
  label_status = Gtk::Label.new "Current"
  label_status.show
  entry_status = Gtk::Entry.new
  tstyle=Gtk::Style.new
  rgb=hexa_to_rgb_color($status_color[$status_value[node.status]])
  tstyle.set_base(Gtk::STATE_NORMAL, rgb.red, rgb.green, rgb.blue)
  entry_status.set_style(tstyle)
  entry_status.set_text($status[$status_value[node.status]])
  entry_status.set_size_request(100,-1)
  entry_status.set_xalign(0.5);
  entry_status.set_editable false
  entry_status.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_status
  table_st.attach(label_status,0,1,0,1)
  table_st.attach(bbox,1,2,0,1)
  vbox.add table_st

  table = Gtk::Table.new(4,2,false)
  table.show

  hsep=Gtk::HSeparator.new
  hsep.show
  vbox.add hsep
  vbox.add table

  label_service = Gtk::Label.new "Service"
  label_service.show
  entry_service = Gtk::Entry.new
  tstyle=Gtk::Style.new
  rgb=hexa_to_rgb_color($status_color[$status_value.index(node.avail_sev)])
  tstyle.set_base(Gtk::STATE_NORMAL, rgb.red, rgb.green, rgb.blue)
  entry_service.set_style(tstyle)
  entry_service.set_text($status[$status_value.index(node.avail_sev)])
  entry_service.set_size_request(100,-1)
  entry_service.set_xalign(0.5);
  entry_service.set_editable false
  entry_service.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_service
  table.attach(label_service,0,1,0,1)
  table.attach(bbox,1,2,0,1)

  label_snmp = Gtk::Label.new "SNMP"
  label_snmp.show
  entry_snmp = Gtk::Entry.new
  tstyle=Gtk::Style.new
  rgb=hexa_to_rgb_color($status_color[$status_value.index(node.snmp_sev)])
  tstyle.set_base(Gtk::STATE_NORMAL, rgb.red, rgb.green, rgb.blue)
  entry_snmp.set_style(tstyle)
  entry_snmp.set_text($status[$status_value.index(node.snmp_sev)])
  entry_snmp.set_size_request(100,-1)
  entry_snmp.set_xalign(0.5);
  entry_snmp.set_editable false
  entry_snmp.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_snmp
  table.attach(label_snmp,0,1,1,2)
  table.attach(bbox,1,2,1,2)

  label_custom = Gtk::Label.new "Custom"
  label_custom.show
  entry_custom = Gtk::Entry.new
  tstyle=Gtk::Style.new
  rgb=hexa_to_rgb_color($status_color[$status_value.index(node.custom_sev)])
  tstyle.set_base(Gtk::STATE_NORMAL, rgb.red, rgb.green, rgb.blue)
  entry_custom.set_style(tstyle)
  entry_custom.set_text($status[$status_value.index(node.custom_sev)])
  entry_custom.set_size_request(100,-1)
  entry_custom.set_xalign(0.5)
  entry_custom.set_editable false
  entry_custom.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_custom
  table.attach(label_custom,0,1,2,3)
  table.attach(bbox,1,2,2,3)

  label_trap = Gtk::Label.new "Trap"
  label_trap.show
  entry_trap = Gtk::Entry.new
  tstyle=Gtk::Style.new
  rgb=hexa_to_rgb_color($status_color[$status_value.index(node.trap_sev)])
  tstyle.set_base(Gtk::STATE_NORMAL, rgb.red, rgb.green, rgb.blue)
  entry_trap.set_style(tstyle)
  entry_trap.set_text($status[$status_value.index(node.trap_sev)])
  entry_trap.set_size_request(100,-1)
  entry_trap.set_xalign(0.5)
  entry_trap.set_editable false
  entry_trap.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_trap
  table.attach(label_trap,0,1,3,4)
  table.attach(bbox,1,2,3,4)

  label = Gtk::Label::new("Status")
  notebook.append_page frame, label

#########################################################################

  frame = Gtk::Frame::new
  frame.border_width=10
  frame.show

  table = Gtk::Table.new(7,2,false)
  table.show
  
  vbox = Gtk::VBox.new
  vbox.show
  frame.add vbox

  entry_type = Gnome::IconEntry.new("Foo","Icon")

  if node.icon[0,1] == '/'
    entry_type.set_pixmap_subdir(node.type)
  else
    entry_type.set_pixmap_subdir("#{PIXMAP_PATH}/type")
  end

  tmp_path_type=find_extension("type/#{node.type}")
  tmp_path_type_table = tmp_path_type.split(/\//)
  entry_type.filename="#{PIXMAP_PATH}/type/"+tmp_path_type_table[1]

  entry_type.show
  vbox.add entry_type

  vbox.add table

  label_xy = Gtk::Label.new "X:Y"
  label_xy.show
  entry_x = Gtk::Entry.new
  entry_x.set_text "#{node.x.to_i}"
  entry_x.set_size_request(10,-1)
  entry_x.set_max_length 4
  entry_x.show
  bbox=Gtk::HButtonBox.new
  #START END SPREAD EDGE
  bbox.set_layout_style Gtk::ButtonBox::SPREAD
  bbox.show
  bbox.add entry_x
  table.attach(label_xy,0,1,0,1)

  entry_y = Gtk::Entry.new
  entry_y.set_text "#{node.y.to_i}"
  entry_y.set_size_request(10,-1)
  entry_y.set_max_length 4
  entry_y.show

  bbox.add entry_y

  table.attach(bbox,1,2,0,1)
  
  label_ip = Gtk::Label.new "IP"
  label_ip.show
  entry_ip = Gtk::Entry.new
  entry_ip.set_text(node.ip)
  entry_ip.set_size_request(200,-1)
  entry_ip.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_ip

  table.attach(label_ip,0,1,1,2)
  table.attach(bbox,1,2,1,2)

  label_mask = Gtk::Label.new "Mask"
  label_mask.show
  entry_mask = Gtk::Entry.new
  entry_mask.set_text node.mask.to_s
  entry_mask.set_size_request(200,-1)
  entry_mask.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_mask

  table.attach(label_mask,0,1,2,3)
  table.attach(bbox,1,2,2,3)

  label_map = Gtk::Label.new "Network"
  label_map.show
  entry_map = Gtk::Combo.new
  entry_map.entry.set_editable false
  entry_map.set_use_arrows true
  netwlist=[]
  $network.each_value {|n|
	netwlist.push n.ip
  }
  entry_map.set_popdown_strings(netwlist)
  entry_map.entry.set_text(node.map)
  entry_map.set_size_request(200,-1)
  entry_map.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_map

  table.attach(label_map,0,1,3,4)
  table.attach(bbox,1,2,3,4)

  label_mac = Gtk::Label.new "MAC"
  label_mac.show
  entry_mac = Gtk::Entry.new
  entry_mac.set_text(node.mac)
  entry_mac.set_size_request(200,-1)
  entry_mac.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_mac

  table.attach(label_mac,0,1,4,5)
  table.attach(bbox,1,2,4,5)

  label_name = Gtk::Label.new "DNS Name"
  label_name.show
  entry_name = Gtk::Entry.new
  entry_name.set_text(node.dns_name)
  entry_name.set_size_request(200,-1)
  entry_name.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_name

  table.attach(label_name,0,1,5,6)
  table.attach(bbox,1,2,5,6)

  label_netbiosname = Gtk::Label.new "Netbios Name"
  label_netbiosname.show
  entry_netbiosname = Gtk::Entry.new
  entry_netbiosname.set_text(node.netbios_name)
  entry_netbiosname.set_size_request(200,-1)
  entry_netbiosname.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_netbiosname

  table.attach(label_netbiosname,0,1,6,7)
  table.attach(bbox,1,2,6,7)

  label_os = Gtk::Label.new "OS"
  label_os.show
  entry_os = Gtk::Combo.new
  entry_os.entry.set_editable false
  entry_os.set_use_arrows true
  entry_os.set_popdown_strings($os)
  entry_os.entry.set_text(node.os)
  entry_os.set_size_request(200,-1)
  entry_os.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_os

  table.attach(label_os,0,1,7,8)
  table.attach(bbox,1,2,7,8)
  
  label_desc = Gtk::Label.new "Description"
  label_desc.show
  entry_desc = Gtk::Entry.new
  entry_desc.set_text(node.description)
  entry_desc.set_size_request(200,-1)
  entry_desc.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_desc

  table.attach(label_desc,0,1,8,9)
  table.attach(bbox,1,2,8,9)

  label = Gtk::Label::new("Information")
  notebook.append_page frame, label

########################################################################

  frame = Gtk::Frame::new
  frame.border_width=10
  frame.set_size_request(300, 290)
  frame.show

  table = Gtk::Table.new(6,2,false)
  table.show
  frame.add table
  
  label_read_community = Gtk::Label.new "Read community"
  label_read_community.show
  $entry_read_community = Gtk::Entry.new
  $entry_read_community.set_text(node.snmpread)
  $entry_read_community.set_size_request(200,-1)
  $entry_read_community.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add $entry_read_community

  table.attach(label_read_community,0,1,0,1)
  table.attach(bbox,1,2,0,1)

  label_write_community = Gtk::Label.new "Write community"
  label_write_community.show
  $entry_write_community = Gtk::Entry.new
  $entry_write_community.set_text(node.snmpwrite)
  $entry_write_community.set_size_request(200,-1)
  $entry_write_community.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add $entry_write_community

  table.attach(label_write_community,0,1,1,2)
  table.attach(bbox,1,2,1,2)


  label_desc = Gtk::Label.new "SNMP description"
  label_desc.show
  entry_descsnmp = Gtk::Entry.new
  entry_descsnmp.set_editable false
  if $config.snmp_mon == "true"
    entry_descsnmp.set_text "(polling...)"
    getDescription(node, $entry_read_community.text, entry_descsnmp)
  else
	 entry_descsnmp.set_sensitive(false)
    entry_descsnmp.set_text "(SNMP is disable)"
  end
  entry_descsnmp.set_size_request(200,-1)
  entry_descsnmp.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_descsnmp

  table.attach(label_desc,0,1,2,3)
  table.attach(bbox,1,2,2,3)

  label_uptime = Gtk::Label.new "SNMP uptime"
  label_uptime.show
  entry_uptime = Gtk::Entry.new
  entry_uptime.set_editable false
  if $config.snmp_mon == "true"
    entry_uptime.set_text "(polling...)"
    getUptime(node, $entry_read_community.text, entry_uptime)
  else
	 entry_uptime.set_sensitive(false)
    entry_uptime.set_text "(SNMP is disable)"
  end
  entry_uptime.set_size_request(200,-1)
  entry_uptime.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_uptime

  table.attach(label_uptime,0,1,3,4)
  table.attach(bbox,1,2,3,4)

  label_contact = Gtk::Label.new "SNMP contact"
  label_contact.show
  entry_contact = Gtk::Entry.new
  entry_contact.set_editable false
  if $config.snmp_mon == "true"
    entry_contact.set_text "(polling...)"
    getContact(node, $entry_read_community.text, entry_contact)
  else
	 entry_contact.set_sensitive(false)
    entry_contact.set_text "(SNMP is disable)"
  end
  entry_contact.set_size_request(200,-1)
  entry_contact.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_contact

  table.attach(label_contact,0,1,4,5)
  table.attach(bbox,1,2,4,5)

  label_location = Gtk::Label.new "SNMP location"
  label_location.show
  entry_location = Gtk::Entry.new
  entry_location.set_editable false
  if $config.snmp_mon == "true"
    entry_location.set_text "(polling...)"
    getLocation(node, $entry_read_community.text, entry_location)
  else
	 entry_location.set_sensitive(false)
    entry_location.set_text "(SNMP is disable)"
  end
  entry_location.set_size_request(200,-1)
  entry_location.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_location

  table.attach(label_location,0,1,5,6)
  table.attach(bbox,1,2,5,6)

  label = Gtk::Label::new("SNMP config")
  notebook.append_page frame, label
########### begin port monitoring #################################

  frame = Gtk::Frame::new
  frame.border_width=10
  frame.show

  vvbox = Gtk::VBox::new
  vvbox.show
  vvbox.add frame

  vbox = Gtk::VBox::new(false,3)
  vbox.show
  frame.add vbox  

#FIXME2!!!    
  #scrolled_window = Gtk::ScrolledWindow.new(nil,nil)
  #scrolled_window.border_width=2
  #scrolled_window.set_policy(Gtk::POLICY_AUTOMATIC,Gtk::POLICY_AUTOMATIC)  
  #vbox.pack_start(scrolled_window, true, true, 0)

  @vbox_ports = Gtk::VBox::new
  @vbox_ports.show

  #scrolled_window.add_with_viewport(vbox_ports)
  #vbox_ports.set_focus_vadjustment(scrolled_window.vadjustment)
  #scrolled_window.show
  vbox.add @vbox_ports
  @scan_port_th=nil
  @cbutton=[]
  @scanned_port_list=nil
######################## nmap thread ##################

	ls = Gtk::ListStore.new(Integer, String, Integer, String)
   @treeview = Gtk::TreeView.new(ls)
	#@treeview.selection.set_mode(Gtk::SELECTION_MULTIPLE)

   renderer = Gtk::CellRendererToggle.new
   renderer.signal_connect('toggled') do |cell, path|
	  # get toggled iter
	  iter = @treeview.model.get_iter(path)
	  fixed =iter[0]
	  # do something with the value
	  fixed ^= 1
	  @cbutton[path.to_i()]=fixed
	  # set new value
	  iter[0] = fixed
   end

	column1 = Gtk::TreeViewColumn.new("Selected",
					 renderer, {:active => 0})
	column1.set_clickable(true)
	column2 = Gtk::TreeViewColumn.new("Protocol",
					 Gtk::CellRendererText.new, {:text => 1})
	column2.set_sort_column_id(1)
	column3 = Gtk::TreeViewColumn.new("Port",
					 Gtk::CellRendererText.new, {:text => 2})
	column3.set_sort_column_id(2)
	column4 = Gtk::TreeViewColumn.new("Service",
					 Gtk::CellRendererText.new, {:text => 3})
	column4.set_sort_column_id(3)

	column1.signal_connect("clicked") do |column|
		toggle_select_port()
	end

	@treeview.append_column(column1)
	@treeview.append_column(column2)
	@treeview.append_column(column3)
	@treeview.append_column(column4)
	@treeview.show

	# Create a menu
	menu_port = Gtk::Menu.new

	item_add_serv = Gtk::MenuItem.new("Add service")
	item_add_serv.signal_connect("activate") { add_monitored_service() }
	menu_port.append(item_add_serv)
	item_del_serv = Gtk::MenuItem.new("Delete selected service")
	item_del_serv.signal_connect("activate") {
		@treeview.model.remove(@treeview.selection.selected) unless @treeview.selection.selected==nil
	}
	menu_port.append(item_del_serv)
	item_edit_serv = Gtk::MenuItem.new("Edit service")
	item_edit_serv.signal_connect("activate") { edit_monitored_service() }
	menu_port.append(item_edit_serv)
	scan_port_serv = Gtk::MenuItem.new("Scan ports")
	scan_port_serv.signal_connect("activate") { scan_port_now(node) }
	menu_port.append(scan_port_serv)
	item_sw_serv = Gtk::MenuItem.new("Swith selected service(s)")
	item_sw_serv.signal_connect("activate") { toggle_select_port() }
	menu_port.append(item_sw_serv)

	menu_port.show_all

	@treeview.signal_connect("button_press_event") do |widget, event|
	  if event.kind_of? Gdk::EventButton and event.button == 3
   	 menu_port.popup(nil, nil, event.button, event.time)
	  end
	end

  fill_port_list(node)
  fill_port_view(node)

  if !($config.port_mon == "true" && $config.nmap_path != "")
	 @treeview.set_sensitive false
	 @treeview.show
  end

  notebook_inside = Gtk::Notebook::new()
  label_port = Gtk::Label::new("Ports")
  notebook_inside.append_page(vvbox, label_port)
  notebook_inside.show

######################### snmp oid monitoring ###################################################################

  frame = Gtk::Frame::new
  frame.border_width=10
  frame.set_size_request(300, 290)
  frame.show

  vbox = Gtk::VBox::new
  vbox.show
  frame.add vbox

  snmp_ls = Gtk::ListStore.new(String, String, String, String)
  @snmpview = Gtk::TreeView.new(snmp_ls)

  if $config.snmp_mon == "false"
		@snmpview.set_sensitive false
  end

  column1 = Gtk::TreeViewColumn.new("OID label",
					Gtk::CellRendererText.new, {:text => 0})
  column1.set_sort_column_id(0)
  column2 = Gtk::TreeViewColumn.new("Operator",
					Gtk::CellRendererText.new, {:text => 1})
  column2.set_sort_column_id(1)
  tr=Gtk::CellRendererText.new
  tr.mode=Gtk::CellRenderer::MODE_EDITABLE
  column3 = Gtk::TreeViewColumn.new("Threshold",
					tr, {:text => 2})
  column3.set_sort_column_id(2)
  column4 = Gtk::TreeViewColumn.new("Severity",
					Gtk::CellRendererText.new, {:text => 3})
  column4.set_sort_column_id(3)

  @snmpview.append_column(column1)
  @snmpview.append_column(column2)
  @snmpview.append_column(column3)
  @snmpview.append_column(column4)
  @snmpview.show

	# Create a menu
	menu_snmp = Gtk::Menu.new

	item_add_snmp = Gtk::MenuItem.new("Add SNMP Ref")
	item_add_snmp.signal_connect("activate") { add_monitored_snmp() unless get_oid_refs_name().size() == 0 }
	menu_snmp.append(item_add_snmp)
	item_del_snmp = Gtk::MenuItem.new("Delete selected SNMP Ref")
	item_del_snmp.signal_connect("activate") {
puts "here"
puts @snmpview.selection.selected
		@snmpview.model.remove(@snmpview.selection.selected) unless @snmpview.selection.selected==nil
	}
	menu_snmp.append(item_del_snmp)
	item_edit_snmp = Gtk::MenuItem.new("Edit SNMP Ref")
	item_edit_snmp.signal_connect("activate") { edit_monitored_snmp() }
	menu_snmp.append(item_edit_snmp)

	menu_snmp.show_all

	@snmpview.signal_connect("button_press_event") do |widget, event|
	  if event.kind_of? Gdk::EventButton and event.button == 3
   	 menu_snmp.popup(nil, nil, event.button, event.time)
	  end
	end

	#populate with saved values
   node.snmp_monitoring.each_value do |snmp_mon|
	  iter = snmp_ls.append
	  iter[0] = snmp_mon.oidref
	  iter[1] = snmp_mon.oper
	  iter[2] = snmp_mon.threshold
	  iter[3] = snmp_mon.severity
	end

	vbox.add(@snmpview)

  label_snmp = Gtk::Label::new("SNMP")
  notebook_inside.append_page frame, label_snmp

###########################end snmp oid monitoring#################################################################

######################### external cmd/plugin monitoring ###################################################################

  frame = Gtk::Frame::new
  frame.border_width=10
  frame.set_size_request(300, 290)
  frame.show

  vbox = Gtk::VBox::new
  vbox.show
  frame.add vbox 

  custom_ls = Gtk::ListStore.new(Integer, String, String)
  @customview = Gtk::TreeView.new(custom_ls)
  
  if $config.custom_mon == "false"
		@customview.set_sensitive false
  end

  renderer = Gtk::CellRendererToggle.new
  renderer.signal_connect('toggled') do |cell, path|
	 # get toggled iter
	 iter = @customview.model.get_iter(path)
	 fixed =iter[0]
	 # do something with the value
	 fixed ^= 1
	 # set new value
	 iter[0] = fixed
  end

  column1 = Gtk::TreeViewColumn.new("Selected",
					renderer, {:active => 0})
  column1.set_clickable(true)
  column2 = Gtk::TreeViewColumn.new("Name",
					Gtk::CellRendererText.new, {:text => 1})
  column2.set_sort_column_id(1)
  column3 = Gtk::TreeViewColumn.new("Description",
					Gtk::CellRendererText.new, {:text => 2})
  column3.set_sort_column_id(2)

  column1.signal_connect("clicked") do |column|
	  toggle_select_custom()
	end

  @customview.append_column(column1)
  @customview.append_column(column2)
  @customview.append_column(column3)
  @customview.show

  #populate with saved values
  $custom_monitor.each do |cm_name|
	 iter = custom_ls.append
	 custom_monitor_class_name=(eval cm_name).name()
	 if node.custom_monitoring.include?(custom_monitor_class_name)
		 iter[0] = 1
	 else
		 iter[0] = 0
	 end		
	 #class name
	 iter[1] = custom_monitor_class_name
	 #detail class name
	 iter[2] = (eval cm_name).new("DONOTHING").name()
  end

  vbox.add(@customview)

  label_custom = Gtk::Label::new("Custom")
  notebook_inside.append_page frame, label_custom

###########################end external cmd/plugin monitoring#################################################################

######################### syslog monitoring ###################################################################

  frame = Gtk::Frame::new
  frame.border_width=10
  frame.set_size_request(300, 290)
  frame.show

  vbox = Gtk::VBox::new
  vbox.show
  frame.add vbox

  syslog_ls = Gtk::ListStore.new(String, String, String)
  @syslogview = Gtk::TreeView.new(syslog_ls)

  if $config.syslog_mon == "false"
		@syslogview.set_sensitive false
  end

  column1 = Gtk::TreeViewColumn.new("Syslog label",
					Gtk::CellRendererText.new, {:text => 0})
  column1.set_sort_column_id(0)
  column2 = Gtk::TreeViewColumn.new("Severity",
					Gtk::CellRendererText.new, {:text => 1})
  column3 = Gtk::TreeViewColumn.new("Description",
					Gtk::CellRendererText.new, {:text => 2})

  @syslogview.append_column(column1)
  @syslogview.append_column(column2)
  @syslogview.append_column(column3)
  @syslogview.show

	# Create a menu
	menu_syslog = Gtk::Menu.new

	item_add_syslog = Gtk::MenuItem.new("Add Syslog Ref")
	item_add_syslog.signal_connect("activate") { add_monitored_syslog() unless get_syslog_refs_name().size() == 0 }
	menu_syslog.append(item_add_syslog)
	item_del_syslog = Gtk::MenuItem.new("Delete selected Syslog Ref")
	item_del_syslog.signal_connect("activate") {
		@syslogview.model.remove(@syslogview.selection.selected) unless @syslogview.selection.selected==nil
	}
	menu_syslog.append(item_del_syslog)
	item_edit_syslog = Gtk::MenuItem.new("Edit Syslog Ref")
	item_edit_syslog.signal_connect("activate") { edit_monitored_syslog() }
	menu_syslog.append(item_edit_syslog)

	menu_syslog.show_all

	@syslogview.signal_connect("button_press_event") do |widget, event|
	  if event.kind_of? Gdk::EventButton and event.button == 3
   	 menu_syslog.popup(nil, nil, event.button, event.time)
	  end
	end

	#populate with saved values
   node.syslog_monitoring.each_value do |syslog_mon|
	  iter = syslog_ls.append
	  iter[0] = syslog_mon.get_syslog_ref()
	  iter[1] = syslog_mon.severity()
	  iter[2] = $syslog_refs[syslog_mon.get_syslog_ref()].description
	end

	vbox.add(@syslogview)

  label_syslog = Gtk::Label::new("Syslog")
  notebook_inside.append_page frame, label_syslog

###########################end syslog monitoring#################################################################

  
  label = Gtk::Label::new("Monitoring")
  notebook.append_page notebook_inside, label

  
######################### graph ###################################################################

#  frame = Gtk::Frame::new("Graphic monitoring")
#  frame.border_width=10
#  frame.set_size_request(300, 300)
#  frame.show

#  label = Gtk::Label::new("Graph")
#  notebook.append_page frame, label

###########################end graph#################################################################

   ok_button = Gtk::Button.new("Save")
   ok_button.signal_connect("clicked") { 
	Thread.kill(@scan_port_th) unless @scan_port_th == nil
	if $config.port_mon == "true" && $config.nmap_path != ""
	  #store services
	  if defined?(@treeview)
		 node.clear_service()
   	 @treeview.model.each {|model, path, iter|
      	 selected 		= iter[0]
	   	 protocol		= iter[1]
	   	 port				= iter[2]
	   	 service_name	= iter[3]
			 node.add_service(protocol, port, service_name, selected)
		 }
 	  end
	end
	#store snmp_monitoring
	node.clear_snmp_monitoring()
   @snmpview.model.each {|model, path, iter|
      oidname 	= iter[0]
	   oper		= iter[1]
	   threshold= iter[2]
	   severity	= iter[3]
		node.add_snmp_monitoring(oidname, oper, threshold, severity)
	}
	#store custom_monitoring
	node.clear_custom_monitoring()
   @customview.model.each {|model, path, iter|
      selected = iter[0]
		if selected == 1
		   name		= iter[1]
			node.add_custom_monitoring(name)
		end
	}

	#store syslog_monitoring
	node.clear_trap_monitoring()
   @syslogview.model.each {|model, path, iter|
      syslog_ref 	= iter[0]
	   severity		= iter[1]
		node.add_syslog_monitoring(syslog_ref, severity)
	}

	#node.refresh_status()

   #general
	if entry_x.text.to_i >= 0 && entry_x.text.to_i <= $win.window.geometry[2]
		node.x = entry_x.text.to_i
	end
	if entry_y.text.to_i >= 0 && entry_y.text.to_i <= $win.window.geometry[3]
		node.y = entry_y.text.to_i
	end

need_reload_icon=0
if entry_os.entry.text != node.os || entry_type.filename != node.type
  need_reload_icon=1
end

  if isValidIp(entry_ip.text)
    node.ip = entry_ip.text
  end
  node.mask = entry_mask.text.to_i
  node.mac = entry_mac.text
  node.dns_name = entry_name.text
  node.netbios_name = entry_netbiosname.text
  node.description = entry_desc.text
  node.snmpread = $entry_read_community.text
  node.snmpwrite = $entry_write_community.text
  node.os = entry_os.entry.text
  if entry_type.filename != nil
    node_type = entry_type.filename
    #FIXME
    temptab=node_type.split(/type\//)
    temptab=temptab[1].split(/\./)
    node.change_type(temptab[0])
  end
  node.change_label()
  if need_reload_icon == 1
    node.reload
  end

	window.destroy
	}

	cancel_button = Gtk::Button.new("Cancel")
	cancel_button.signal_connect("clicked") {
		Thread.kill(@scan_port_th) unless @scan_port_th == nil
		#node.service=$savedport
		window.destroy
	}
	
	hbox=Gtk::HBox.new(FALSE, 10)
	hbox.border_width=10
	hbox.show
	hbox.pack_start(ok_button, TRUE, TRUE, 0)
	ok_button.set_flags(Gtk::Widget::CAN_DEFAULT);
	hbox.pack_start(cancel_button, TRUE, TRUE, 0)
	cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT);
	separator = Gtk::HSeparator::new()
	vboxb.pack_start(separator, FALSE, TRUE, 0)
	separator.show
	vboxb.pack_start(hbox, FALSE, TRUE, 0)
	ok_button.show
	cancel_button.show

	window.show
    
  end
end
