class NodeHostView < NodeView

	def set_type(typ)
		points=nil
		icon_x, icon_y = @icon.parent.w2i(node.x,node.y)
		case typ
		when "printer"
			#hexagone: device
			points = [[icon_x+get_node_size()/6.0, icon_y], [icon_x+5*get_node_size()/6.0, icon_y], [icon_x+get_node_size(), icon_y+get_node_size()/2.0], [icon_x+5*get_node_size()/6.0, icon_y+get_node_size() ], [icon_x + get_node_size()/6.0, icon_y+get_node_size()], [icon_x, icon_y+get_node_size()/2.0]]
		when "router" 
			#losange
			points = [[icon_x+get_node_size()/2.0, icon_y], [icon_x, icon_y+get_node_size()/2.0], [icon_x+get_node_size()/2.0, icon_y+get_node_size()], [icon_x+get_node_size(), icon_y+get_node_size()/2.0] ]
		when "firewall"
			#losange
			points = [[icon_x+get_node_size()/2.0, icon_y], [icon_x, icon_y+get_node_size()/2.0], [icon_x+get_node_size()/2.0, icon_y+get_node_size()], [icon_x+get_node_size(), icon_y+get_node_size()/2.0] ]
		when "switch"
			#octogone
			points = [[icon_x+get_node_size()/3.0, icon_y], [icon_x+2*get_node_size()/3.0, icon_y], [icon_x+get_node_size(), icon_y+get_node_size()/3.0], [icon_x+get_node_size(), icon_y+2*get_node_size()/3.0], [icon_x+2*get_node_size()/3, icon_y+get_node_size()], [icon_x+get_node_size()/3.0, icon_y+get_node_size()], [icon_x,icon_y+2*get_node_size()/3.0], [icon_x, icon_y+get_node_size()/3.0]]
		end
		if points != nil
			@icon.destroy
			@icon=Gnome::CanvasPolygon.new(@group, 
								{:points => points,
			 					 :fill_color_rgba => $status_color[$status_value.index(node.status)],
                         :outline_color => "black",
                         :width_units => 1.0})
			@icon.lower_to_bottom()
		end
	end

  def setup_rectangle(root, status, icon_file, label)

	#node_view=Struct.new("NodeView", :rect, :label)

   @group = Gnome::CanvasGroup.new(root,{:x => 0.0,:y => 0.0})
	@group.hide

	@icon=Gnome::CanvasRect.new(@group,
                                       {:x1 => node.x,
                                         :y1 => node.y,
                                         :x2 => node.x+get_node_size(),
                                         :y2 => node.y+get_node_size(),
					 								  :fill_color_rgba => status,
                                         :outline_color => "black",
                                         :width_units => 1.0})

	if (icon_file == nil) || (!FileTest.exist?(icon_file))
		icon_file="#{PIXMAP_PATH}/unknown.png"
	end
	im=Gdk::Pixbuf.new(icon_file)
	@image=Gnome::CanvasPixbuf.new(@group,
                                      {:pixbuf => im,
				      						  :x => @icon.x1+($config.pixmap_size/2),
                                      :y => @icon.y1+($config.pixmap_size/2),
	 			      						  :anchor => Gtk::ANCHOR_CENTER,
												  :width_set => true,
												  :height_set => true,
                                      :width => $config.pixmap_size*80/100,
                                      :height => $config.pixmap_size*80/100}
											)
    
	if label == nil
		label = ""
	end

	@bg_text=Gnome::CanvasRect.new(@group,
                                       {:x1 => @icon.x1+((@icon.x2-@icon.x1)/2)-label.size*3.3,
                                         :y1 => @icon.y2+get_node_size()/5-5,
                                         :x2 => @icon.x1+((@icon.x2-@icon.x1)/2)+label.size*3.3,
                                         :y2 => @icon.y2+get_node_size()/5+5,
					 								  :fill_color => "grey",
                                         :width_units => 1.0})

	@text=Gnome::CanvasText.new(@group,
                            {:text => label,
                            :x => @icon.x1+((@icon.x2-@icon.x1)/2),
                            :y => @icon.y2+get_node_size()/5,
                            :font => "Sans 8",
			    					 :anchor => Gtk::ANCHOR_CENTER,
                            :fill_color => "black"})


	setup_item(@group)
  end

 #define a tooltip
  def show_tooltips()
	if @tooltips==nil
		@tooltips=Gtk::Window.new(Gtk::Window::POPUP)
		@tooltips.set_decorated(false)
		@tooltips.set_size_request(-1,-1)
		@tooltips.set_window_position(Gtk::Window::POS_NONE)
		@tooltips.border_width=1
		x,y=$win.position
		@tooltips.move(node.x+x+50, node.y+y+40)
@tooltips.app_paintable=true
@tooltips.realize
drawable=@tooltips.window
gc = Gdk::GC.new(drawable)

#green = Gdk::Color.new(0, 65535, 0)
#colormap = Gdk::Colormap.system
#colormap.alloc_color(green, false, true)

	@tooltips.modify_bg(Gtk::STATE_NORMAL,$light_yellow)
	@tooltips.signal_connect("expose-event") do |win, evt|
	tooltips_width, tooltips_height=@tooltips.size

	 drawable.draw_rectangle(gc,false, 0, 0, tooltips_width-1, tooltips_height-1)
	 drawable.draw_rectangle(gc,false, 1, 1, tooltips_width-3, tooltips_height-3)
	 false

	 end
		vbox=Gtk::VBox.new
	  vbox.border_width=5
	   ttips_text="<span weight=\"bold\" size=\"small\">IP: </span>#{self.node.ip}"
		ttips_text+="\n<span weight=\"bold\" size=\"small\">Mask: </span>#{self.node.mask}"
     if self.node.dns_name?
	     ttips_text+="\n<span weight=\"bold\" size=\"small\">Dns name: </span>#{self.node.dns_name}"

     end
     if self.node.description?() &&( self.node.description != "")
	     ttips_text+="\n<span weight=\"bold\" size=\"small\">Description: </span>#{self.node.description}"
     end
	  label = Gtk::Label.new.set_markup(ttips_text)
	  label.set_alignment(0,0.5)
	  vbox.add label

     if self.node.os && (self.node.os != "unknown")
			tos=Gtk::Table.new(1,0,false)
			vbox.add tos
			label_os = Gtk::Label.new.set_markup("<span weight=\"bold\" size=\"small\">OS: </span>")
			label_os.set_alignment(0,0.5)
			label_os.show
			tos.add label_os
			pxb = Gdk::Pixbuf.new(PIXMAP_PATH+"/#{find_extension("os/#{self.node.os}")}",20,20)
			pxb_pixmap,pxb_mask=pxb.render_pixmap_and_mask(128)
			img=Gtk::Image.new(pxb_pixmap,pxb_mask)
			img.show
			tos.attach(img,0,1,0,1, Gtk::FILL)
			tos.show
     end

     if self.node.type
			ttype=Gtk::Table.new(1,0,false)
			vbox.add ttype
			label_type = Gtk::Label.new.set_markup("<span weight=\"bold\" size=\"small\">Type: </span>")
			label_type.set_alignment(0,0.5)
			label_type.show
			ttype.add label_type
			pxb = Gdk::Pixbuf.new(PIXMAP_PATH+"/#{find_extension("type/#{self.node.type}")}",20,20)
			pxb_pixmap,pxb_mask=pxb.render_pixmap_and_mask(128)
			img=Gtk::Image.new(pxb_pixmap,pxb_mask)
			img.show
			ttype.attach(img,0,1,0,1, Gtk::FILL)
			ttype.show
     end
		sev_str=$status[$status_value.index(self.node.avail_sev)]
		ttips_text_sev="<span weight=\"bold\" size=\"small\">Port Severity: </span><span color=\"##{rgb_to_hex_color(get_color_from_status(sev_str))}\">#{sev_str}</span>"
		sev_str=$status[$status_value.index(self.node.snmp_sev)]
		ttips_text_sev+="\n<span weight=\"bold\" size=\"small\">SNMP Severity: </span><span color=\"##{rgb_to_hex_color(get_color_from_status(sev_str))}\">#{$status[$status_value.index(self.node.snmp_sev)]}</span>"
		sev_str=$status[$status_value.index(self.node.custom_sev)]
		ttips_text_sev+="\n<span weight=\"bold\" size=\"small\">Custom Severity: </span><span color=\"##{rgb_to_hex_color(get_color_from_status(sev_str))}\">#{$status[$status_value.index(self.node.custom_sev)]}</span>"
	  label_sev = Gtk::Label.new.set_markup(ttips_text_sev)
	  label_sev.set_alignment(0,0.5)
		label_sev.show
	  vbox.add label_sev


	  vbox.show
	  label.show

	  @tooltips.add vbox
	end
	if !@tooltips.visible?
		@tooltips.show()
	end

  end

	def hide_tooltips()
		if @tooltips != nil
			@tooltips.hide()
			#with this the tooltips is always refreshed
			@tooltips.destroy
			@tooltips=nil
		end
	end

  def initialize(rootcanvas, nd, status, icon_file, label)
    @dragging=false
	 @size=get_node_size()
    @tooltips=nil
    self.node=nd
    self.selected=false
    setup_rectangle(rootcanvas, status, icon_file, label)
  end

end
