class NodeView

MIN_MOVE=5
NODE_SIZE=40

attr_accessor :icon, :image, :bg_text, :text, :selected, :group
attr_accessor :node

	def move_up()
		move(0, -MIN_MOVE)
	end
	def move_down()
		move(0, MIN_MOVE)
	end
	def move_left()
		move(-MIN_MOVE, 0)
	end
	def move_right()
		move(MIN_MOVE, 0)
	end

	def get_node_size()
		view_size=$config.pixmap_size.to_i()
		if view_size <= 0
			return NODE_SIZE
		else
			return view_size
		end
	end

	def reparent(canvas_group)
		@group.reparent(canvas_group)
	end

	def get_size()
		return @size
	end

	def resize()
		to_size=$config.pixmap_size
		if @node.map != nil
			if $network[@node.map].node_size != nil
				to_size=$network[@node.map].node_size
			end
		end
		if to_size != get_size()
			@size=$config.pixmap_size
			icon_x, icon_y = @icon.parent.w2i(node.x,node.y)
			if @icon.class == Gnome::CanvasPolygon
				set_type(@node.type)
			else
				@icon.x1=icon_x
				@icon.y1=icon_y
				@icon.x2=icon_x+to_size
				@icon.y2=icon_y+to_size
			end
			@image.x=icon_x+(to_size/2)
			@image.y=icon_y+(to_size/2)
			@image.width_set=true
			@image.height_set=true
			@image.width=to_size*80/100
			@image.height=to_size*80/100

			@text.x=icon_x+(to_size/2)
      	@text.y=icon_y-1+to_size+get_node_size()/4
			reload_bg_text()
		end
	end

  #
  #	need to reload bg text when text label is changed
  #
  def reload_bg_text()
		@bg_text.x1=@icon.x1+((@icon.x2-@icon.x1)/2)-@text.text.size*3.3
		@bg_text.y1=@icon.y2+get_node_size()/5-5
		@bg_text.x2=@icon.x1+((@icon.x2-@icon.x1)/2)+@text.text.size*3.3
		@bg_text.y2=@icon.y2+get_node_size()/5+5
  end

  def selected?()
 	return @selected==true
  end

  def select()
		@icon.set({:outline_color => "red"})
		@selected=true
  end

  def unselect()
		@icon.set({:outline_color => "black"})
    	#@text.set({:fill_color => "black"})
		@selected=false
  end

  def move(x_translate, y_translate)
	  @group.move(x_translate, y_translate)
	  @node.x=node.x+(x_translate)
	  @node.y=node.y+(y_translate)
  end

  def destroy()
	 @group.destroy
  end

  def show()
	@group.show
  end

  def hide()
	@group.hide
  end

  def set_text_color(color)
	if @text != nil
	    @text.set({:fill_color => color})
	end
  end

  def set_text(txt)
  	if (@text != nil) && (@text.text != txt)
 		@text.set({:text => txt})
		reload_bg_text()
	end
  end

  def get_text()
  	if @text != nil
		@text.text
	end
  end

  def hide_text()
  	if @text != nil
		@bg_text.hide()
		@text.hide()
	end
  end

  def show_text()
  	if @text != nil
		@bg_text.show()
		@text.show()
	end
  end

  def set_image(img_path)
	if @image != nil
	   full_img_path="#{PIXMAP_PATH}/"+img_path
	   if FileTest.exist?(full_img_path)
		   @image.set({:pixbuf => Gdk::Pixbuf.new(full_img_path)})
	   end
	end
  end

  def icon_color(color)
	if @icon != nil
	    	@icon.set({:fill_color_rgba => color})
	end
  end

  private
  def item_event(item, event)

    case event.event_type
    when Gdk::Event::KEY_PRESS
	estring=Gdk::Keyval.to_name(event.keyval)
#   print "code touche: ",event.keyval," = ",estring,"\n"
	if event.keyval == 65535 || estring == 'd' || estring == 'D'#it s 'suppr' key or 'd' key
		#we want to delete a node!
	       delnodewin(node)
   end
    when Gdk::Event::ENTER_NOTIFY
		#@text.set({:fill_color => "green"})
		#puts "mouse over"
			if to_b($config.show_tooltips)
				@ttips=Thread.start {
					sleep(3)
					show_tooltips()
				}
			end
    when Gdk::Event::LEAVE_NOTIFY
		#puts "mouse out"
 	 	#@text.set({:fill_color => "black"})
		if defined?(@ttips)
			hide_tooltips()
			Thread.kill(@ttips)		
		end
    when Gdk::Event::BUTTON2_PRESS
		#show links cause hide during first button check
  		$canvas.get_selected_node.each {|n|
		  if n.nb_links > 0
			  n.get_links().each {|lnk|
				lnk.show
			  }
		  end
		}
		if node.class == Network
			set_map(self.node.ip)
		else
			node_property(self.node)			
		end
    when Gdk::Event::BUTTON_PRESS
      item_x, item_y = item.parent.w2i(event.x,event.y)
      case event.button
      when 1
        if event.state & Gdk::Window::SHIFT_MASK == Gdk::Window::SHIFT_MASK
          item.destroy()
        else
          @x = item_x;
          @y = item_y;
          #fleur = Gdk::Cursor.new(Gdk::Cursor::FLEUR)
          #item.grab(Gdk::Event::POINTER_MOTION_MASK | Gdk::Event::BUTTON_RELEASE_MASK,
          #          fleur,
          #          event.time)
          @dragging = true
			 if !selected?
				 $canvas.get_selected_node.each {|n|
					 n.node_view.unselect()
				 }
				 select()
			 end
			 #hide links before moving nodes
  			 $canvas.get_selected_node.each {|n|
				if n.nb_links > 0
					n.get_links().each {|lnk|
				  	 lnk.hide
				  	}
				end
			 }
        end
      when 3
		#popup menu
                b = event.button
                t = event.time

                popup_menu = Gtk::Menu.new
                popup_menu.append(Gtk::SeparatorMenuItem.new)
                if node.status == UNMANAGED
                  popup_menu.append(ismon=Gtk::MenuItem.new("Start Monitoring"))
                else
                  popup_menu.append(ismon=Gtk::MenuItem.new("Stop Monitoring"))
                end
					 map_menu_item=Gtk::MenuItem.new("Move to map")
					 if get_map() != nil
						map_menu=Gtk::Menu.new
						$network.each_value {|node_map|
								if get_map() != node_map.ip && node_map.ip != node.ip
								  map_menu.append(actme=Gtk::MenuItem.new(node_map.ip))
								  actme.signal_connect('button-press-event') {
									  node.set_map(node_map.ip)
									  $canvas.get_selected_node().each {|n|
									  		n.set_map(node_map.ip)
									  }
									  node_map.update_status(node_map,node_map.status)
								  }
								end
						}
						map_menu_item.set_submenu(map_menu)
					 else
						map_menu_item.set_sensitive false
					 end
                popup_menu.append(map_menu_item)
					
                popup_menu.append(deletenode=Gtk::MenuItem.new("Delete"))
					 if get_map() == nil 
						deletenode.set_sensitive false
					 end
					 popup_menu.append(linknode=Gtk::MenuItem.new("Link"))
					 if get_map() == nil || $canvas.nb_selected() != 2
						linknode.set_sensitive false
					 end
                popup_menu.append(Gtk::SeparatorMenuItem.new)
					
					if node.class == Host
					 admin_menu_item=Gtk::MenuItem.new("Admin")
					 admin_menu=Gtk::Menu.new

                admin_menu.append(ssh=Gtk::MenuItem.new("Ssh"))
					 if $config.ssh_path == "" || $config.xterm_path == ""
						 ssh.set_sensitive false
      					 end
					 admin_menu.append(telnet=Gtk::MenuItem.new("Telnet"))
					 if $config.telnet_path == "" || $config.xterm_path == ""
						 telnet.set_sensitive false
					 end
     			    admin_menu.append(browser=Gtk::MenuItem.new("Web"))
					 if $config.browser_path == "" || $config.xterm_path == ""
						 browser.set_sensitive false
					 end
                admin_menu.append(vnc=Gtk::MenuItem.new("VNC"))
					 if $config.vncviewer_path == "" || $config.xterm_path == ""
						 vnc.set_sensitive false
					 end
					 admin_menu.append(rdp=Gtk::MenuItem.new("RDP"))
					 if $config.vncviewer_path == "" || $config.xterm_path == ""
						 rdp.set_sensitive false
					 end
					 admin_menu_item.set_submenu(admin_menu)

               ssh.signal_connect('button-press-event') {
                  Thread.start {
                    if $xterm_path !=""
                      system("#{$xterm_path} #{$config.ssh_path} #{node.ip}")
                    end
                  }
                  popup_menu.destroy
                }
					telnet.signal_connect('button-press-event') {
                  Thread.start {
                  if $config.xterm_path !=""
                    system("#{$config.xterm_path} #{$config.telnet_path} #{node.ip}")
                  end
                  }
                  popup_menu.destroy
                }
                browser.signal_connect('button-press-event') {
                  Thread.start {
                  if $config.xterm_path !=""
                    system("#{$config.browser_path} http://#{node.ip}")
                  end
                  }
                  popup_menu.destroy
                }
                vnc.signal_connect('button-press-event') {
                  Thread.start {
                    if $config.xterm_path !=""
                      system("#{$config.xterm_path} #{$config.vncviewer_path} #{node.ip}:1")
                    end
                  }
                  popup_menu.destroy
                }
                rdp.signal_connect('button-press-event') {
                  Thread.start {
                    if $config.xterm_path !=""
                      system("#{$config.xterm_path} #{$config.rdesktop_path} #{node.ip}")
                    end
                  }
                  popup_menu.destroy
                }
					popup_menu.append(admin_menu_item)
					elsif node.class == Network
					 popup_menu.append(enter_network=Gtk::MenuItem.new("Go down"))
					 enter_network.signal_connect('button-press-event') {
						set_map(self.node.ip)
					 }
					end

	            popup_menu.append(Gtk::SeparatorMenuItem.new)

            	popup_menu.append(event_win_host=Gtk::MenuItem.new("Show events"))
            	popup_menu.append(property=Gtk::MenuItem.new("Property"))
					if node.status==UNMANAGED
						property.set_sensitive(false)
					end
            	popup_menu.show_all
            	popup_menu.popup(nil,nil,b,t)

               ismon.signal_connect('button-press-event') {
                 if node.status == UNMANAGED
						 node.set_all_severity(UNKNOWN)
						 $canvas.get_selected_node().each {|n|
						 	n.set_all_severity(UNKNOWN)
						}
                 else
						 node.set_all_severity(UNMANAGED)
						 $canvas.get_selected_node().each {|n|
						 	n.set_all_severity(UNMANAGED)
						}
                 end
					  #refresh network map status
						$network[node.map].update_status(node,UNMANAGED)
                 popup_menu.destroy
              }
              deletenode.signal_connect('button-press-event') {
              	  delnodewin(node)
                 popup_menu.destroy
              }
              linknode.signal_connect('button-press-event') {
                 if $canvas.nb_selected() == 2
							node_t=$canvas.get_selected_node()
							lnk=Link.new(node_t[0], node_t[1])
							$links.push(lnk)
							node_t[0].add_link(lnk)
							node_t[1].add_link(lnk)
					  end
                 popup_menu.destroy
              }         
              property.signal_connect('button-press-event') { |w,s|
                node_property(self.node)
                popup_menu.destroy
              }
				  event_win_host.signal_connect('button-press-event') {
					 $event_win.filter_by_node(self.node)
                $event_win.show()
                popup_menu.destroy
              }
  
					#end of popup menu
             end
    when Gdk::Event::BUTTON_RELEASE
      @dragging = false;
    when Gdk::Event::MOTION_NOTIFY
      item_x, item_y = item.parent.w2i(event.x, event.y)
      if @dragging && (event.state & Gdk::Window::BUTTON1_MASK == Gdk::Window::BUTTON1_MASK)
			nodex=node.x+(item_x - @x)
	   	nodey=node.y+(item_y - @y)
			#test if node is not out of the view
			if nodex >=0 && nodey >=0 && nodex+get_node_size() <= ($win.window.geometry[2]-$win.window.geometry[0]) && nodey+get_node_size() <= ($win.window.geometry[3]-$win.window.geometry[1])
			  node.x=nodex
	   	  node.y=nodey
			  @group.move(item_x - @x, item_y - @y)
			  mapp=get_map()
			  if mapp != nil
	      	  $network[mapp].host.each_value {|n|
	   			  if n.node_view.selected?() and n!=node
      				  n.node_view.move(item_x - @x, item_y - @y)
					  end
	      	  }
			  end
      	  @x = item_x;
      	  @y = item_y;
   	   end
      end
	 end
  end

  def setup_item(item)
    item.signal_connect("event") do |item, event|
      item_event(item, event)
    end
  end

end
