require 'gtk2'
require "#{GNMSLIB}"+'module/gui/color_macro'

class TreeNodeWindow

	def visible?()
		return @treenode.visible?()
	end

	def show()
		if !$treenode_win.visible?
  			 reload()
		end
		@treenode.show()
	end

	def hide()
		@treenode.hide()
	end

	def clear()
		@tree_store.clear()
	end

	def del_row(node)
puts "dans del_row"
		iter=search_node(node)
		if iter != nil
			@tree_store.remove(@tree_store.get_iter(iter))
			if node.class == Host
				iter=search_node($network[node.map])
				#adjust network map nb hosts
				str_tmp=@tree_store.get_value(@tree_store.get_iter("#{iter}"),1)
				str_tmp.scan(@re) do |network_ip, nb_host|
					nb_host=1 unless nb_host.to_i() > 0
					@tree_store.set_value(@tree_store.get_iter("#{iter}"),1,"#{network_ip} (#{nb_host.to_i()-1})")
				end
			end
		end
	end

	def add_row(node)
puts "dans add_row"
		if search_node(node) == nil
		if node.class == Network
				root_iter = @tree_store.append(nil)
  	   		hexa_rgb=$status_color[$status_value.index(node.status)]
				root_iter[0] = hexa_to_rgb_color(hexa_rgb)
				root_iter[1] = node.ip
		elsif node.class == Host
			#search for network map
			iter_map=search_node($network[node.map])
			if iter_map != nil
				root_iter = @tree_store.append(@tree_store.get_iter(iter_map))
  	   		hexa_rgb=$status_color[$status_value.index(node.status)]
				root_iter[0] = hexa_to_rgb_color(hexa_rgb)
				root_iter[1] = node.ip
				#adjust network map nb hosts
				str_tmp=@tree_store.get_value(@tree_store.get_iter("#{iter_map}"),1)
				str_tmp.scan(@re) do |network_ip, nb_host|
					@tree_store.set_value(@tree_store.get_iter("#{iter_map}"),1,"#{network_ip} (#{nb_host.to_i()+1})")
				end
			end
		end
		end
	end

	#
	#	return an iter if node is found
	#
	def search_node(node)
		if node.class == Network
			iter_pos=0 
			while @tree_store.get_iter("#{iter_pos}") != nil do
				if @tree_store.get_value(@tree_store.get_iter("#{iter_pos}"),1).index(node.ip) == 0
					return "#{iter_pos}"
				end
				iter_pos+=1
			end
		elsif node.class == Host
			#we first search for the network
			iter_pos=0 
			while @tree_store.get_iter("#{iter_pos}") != nil do
				if @tree_store.get_value(@tree_store.get_iter("#{iter_pos}"),1).index(node.map) == 0
					host_iter_pos=0
					while @tree_store.get_iter("#{iter_pos}:#{host_iter_pos}") != nil do
						if @tree_store.get_value(@tree_store.get_iter("#{iter_pos}:#{host_iter_pos}"),1).index(node.ip) == 0					
							return "#{iter_pos}:#{host_iter_pos}"
						end
						host_iter_pos+=1
					end
					return nil
				end
				iter_pos+=1
			end
		end
		return nil
	end

	#global sev has changed for the given node
	def update_row(node)
		iter=search_node(node)
		if iter != nil
			@tree_store.set_value(@tree_store.get_iter("#{iter}"), 0, get_color_from_status($status[$status_value.index(node.status)]))
		end
	end

	def reload()
	  clear()
	  $network.sort{|ip1,ip2| 
				ip1_tmp=fill_ip_str(ip1[0])
				ip2_tmp=fill_ip_str(ip2[0])
				ip1_tmp<=>ip2_tmp
			}.each {|ip,node|
		  root_iter = @tree_store.append(nil)
		  hexa_rgb=$status_color[$status_value.index($network[ip].status)]
		  root_iter[0] = hexa_to_rgb_color(hexa_rgb)
		  
    	  cpt=0
		  $network[ip].host.sort{|ip1,ip2| 
				ip1_tmp=fill_ip_str(ip1[0])
				ip2_tmp=fill_ip_str(ip2[0])
				ip1_tmp<=>ip2_tmp
			}.each {|ipt, node|
			 if node.class != Network
				 cpt+=1
				 child_iter = @tree_store.append(root_iter)
  	   		 hexa_rgb=$status_color[$status_value.index(node.status)]
				 child_iter[0] = hexa_to_rgb_color(hexa_rgb)
				 child_iter[1] = node.ip
			 end
		 }
 	    root_iter[1] = "#{ip} (#{cpt})"
	  }
	end

	def initialize()


	  @re=Regexp.new('^([\d.]+) \((\d+)\)$')
	  @column_title_expand="Expand all networks"
	  @column_title_collapse="Collapse all networks"
	  @node_selected=nil

	  @treenode = Gtk::Window.new
	  @treenode.set_size_request(200,200)
	  @treenode.set_title "Tree node"
	  @tree_store=Gtk::TreeStore.new(Gdk::Color,String)

	  vbox=Gtk::VBox.new
	  vbox.show
	  @treenode.add vbox

	  scrolled_window = Gtk::ScrolledWindow.new(nil, nil)
	  scrolled_window.border_width=2
	  scrolled_window.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC)  

	  vbox.pack_start(scrolled_window, true, true, 0)
	  scrolled_window.show

	  tv = Gtk::TreeView.new(@tree_store)
	  renderer = Gtk::CellRendererText.new
	  column = Gtk::TreeViewColumn.new(@column_title_expand, renderer, {
                                 		 :background_gdk => 0,
                                 		 :text => 1
                                 	  })
		tv.set_headers_clickable(true)
		tv.set_headers_visible(true)
	   column.set_clickable(true)
		column.set_alignment(0.5)
	   column.signal_connect("clicked") {
			if column.title == @column_title_expand
				column.title=@column_title_collapse
				tv.expand_all
			else
				column.title=@column_title_expand
				tv.collapse_all
			end			
		}
	  tv.append_column(column)
	  tv.show
	  scrolled_window.add(tv)

	#tv.signal_connect("button_press_event") {|trv,e,t|
	tv.signal_connect("row-activated") {|trv,path|

		if path.to_str.match(/\d+:\d+/)
			ptt=path.to_str.split(":")
			path_tmp=ptt[0]
			iter=trv.model.get_iter(path_tmp)
			#1 is the second column
			map=trv.model.get_value(iter,1)
			#delete number of host at the end of map name
			set_map(map.gsub(/ \(.+$/,''))

			#we double click a node item
			iter=trv.model.get_iter(path)
			#1 is the second column
			ip=trv.model.get_value(iter,1)
			if @node_selected != nil
				@node_selected.node_view.unselect()
			end
			if $host[ip] == nil
				@node_selected=$network[ip]
				$network[ip].node_view.select() unless $network[ip] == nil
			else
				@node_selected=$host[ip]
				$host[ip].node_view.select()
			end
		else
			iter=trv.model.get_iter(path)
			#1 is the second column
			map=trv.model.get_value(iter,1)
			#delete number of host at the end of map name
			set_map(map.gsub(/ \(.+$/,''))
		end
	}

	tv.signal_connect("key_press_event") {|trv,e|
		if e.keyval==Gdk::Keyval::GDK_Delete
			ip=""
			path,focus_col=trv.cursor()
			iter=trv.model.get_iter(path)
			if path.to_str.match(/\d+:\d+/)
				ip=trv.model.get_value(iter,1)
				delnodewin($host[ip])
			else
				ip=trv.model.get_value(iter,1).gsub(/ \(.+$/,'')
				delnodewin($network[ip])
			end
		end
	}
	  @treenode.signal_connect("delete_event") do
			@treenode.hide
	  end
	  @treenode.signal_connect("key_press_event") {|w,e|
		if e.keyval==Gdk::Keyval::GDK_Escape
      	@treenode.hide()
   	end
	  }
	end
end
