class Network < Node
   attr_accessor :name, :dns_domain, :netbios_domain, :host, :node_view, :map_view, :node_size, :map_bg_type, :map_bg_data

   def initialize (ip="",netmask=24, mp=nil, p=nil, s=UNKNOWN, xd=0 ,yd=0, i="", d=NODESCR_PROPERTY, sr="public", sw="public", t="network", o="unknown", n=NONAME_PROPERTY, dns_domain=NONAME_PROPERTY, netbios_domain=NONAME_PROPERTY)

      super(ip, netmask, mp, p, s, xd, yd, i, d, sr, sw, t, o)
      @name=n
      @dns_domain=NONAME_PROPERTY
      @netbios_domain=NONAME_PROPERTY
      @host=Hash.new
      @node_view=nil
		@node_size=nil
		@map_bg_type=nil
		@map_bg_data=nil
      create_node()
   end

   def name?()
	   return @name != nil
   end

	#
	# h is a node
	#
   def add_host(h)
		if $treenode_win.visible?
			$treenode_win.add_row(h)
		end
		@host[h.ip]=h
   end

   def del_host(hip)
		if $treenode_win.visible?
			$treenode_win.del_row(@host[hip])
		end
		@host.delete hip
   end

   def contain_host(hip)
		@host.each_value {|node|
			if node.ip == hip
				return true
			end
		}
		return false
   end
	
	def nb_host()
		return @host.size
	end

   def dns_domain?()
	   return dns_domain != NONAME_PROPERTY
   end

   def netbios_domain?()
	   return netbios_domain != NONAME_PROPERTY
   end

	#
	# method for changing status (color) of the node
	#  
	def change_status(st)
		if @status != st
      	#status has changed
      	@status=st
      	@node_view.icon_color($status_color[$status_value.index(st)])

			if $treenode_win.visible?
				$treenode_win.update_row(self)
			end

			#propagate status to all nodes in this network
			@host.each_value {|node|
				node.change_status(st)
			}
		end
	end

#
# update status depending on node host
#
	def update_status(node,status)
			total_up=0
			total_other=0
	   	@host.each_value{|n|
				if n.status == NORMAL
					total_up+=1
				elsif n.status != UNMANAGED
					total_other+=1
				end
			}
			total_host=total_up+total_other
			if total_host > 0
				percent_status_not_up=(total_other*100)/total_host
#print node.ip, " ",percent_status_not_up,"\n"
				if percent_status_not_up >= 50
					@status=CRITICAL
					@node_view.icon_color($status_color[$status_value.index(CRITICAL)])
				elsif percent_status_not_up == 0
					@status=NORMAL
					@node_view.icon_color($status_color[$status_value.index(NORMAL)])
				elsif	percent_status_not_up >= 25
					@status=MAJOR
					@node_view.icon_color($status_color[$status_value.index(MAJOR)])
				else
					@status=MINOR
					@node_view.icon_color($status_color[$status_value.index(MINOR)])
				end
				if $treenode_win.visible?
					$treenode_win.update_row(self)
				end
				#need to propagate to the network upstair
				$network[@map].update_status(self,@status) unless @map == nil
			end
	end

	#
	# method for changing label of the node
	# lb is nil when we just want a node label refresh
	def change_label(lb=nil)
	 if to_b($config.show_label) == true
		 if (@old_label != lb) or lb==nil
	       @old_label=lb unless lb==nil
			 lb=@old_label unless lb!=nil
		    node_view.set_text("#{eval lb}") unless ("#{eval lb}" == NODESCR_PROPERTY) || ("#{eval lb}" == NONAME_PROPERTY)
	     end
	 end
	end
      
	def create_node()
		@old_label=""
      #set default label
		label="#{dns_domain}"
      if !dns_domain? && ip != ""
	     	label="#{ip}"
	   	if name?
				label="#{@name}"
	     	end
      end
		@map_view=Gnome::CanvasGroup.new($canvas_root,{:x => 0.0,:y => 0.0})
		@map_view.hide()
#puts @ip
		@node_view=nil
		if @map == nil
			#its the root network
			@node_view=NodeNetworkView.new($canvas_root, self, $status_color[$status_value.index(status)], "#{PIXMAP_PATH}/#{icon}", label)
		else
			@node_view=NodeNetworkView.new($network[@map].map_view, self, $status_color[$status_value.index(status)], "#{PIXMAP_PATH}/#{icon}", label)			
		end
		change_label($config.network_label_view)
      if (to_b($config.show_label) == true)&&($map==@map)
			@node_view.show_text()
		else
			@node_view.hide_text()
		end
	end #create_node

	def delete()
	 #first need to destroy the links
	 del_all_links()
	 #first need to destroy the view
	 @node_view.destroy()
	 del_network(@ip)
	end

   #reload pixmap icon to apply changes
   def reload()
     if ($config.network_icon_view=="os")
       @icon="#{find_extension("os/#{@os}")}"
     else
       @icon="#{find_extension("type/#{@type}")}"
     end
     @node_view.set_image(@icon)
   end

  #
  # Return a table for the find tool
  #
  def to_t
    tmp=[]
    tmp.push(@ip,$status[$status_value.index(@status)], @name, @dns_domain, @netbios_domain, @description, @type, @os)
    return tmp
  end

end #class
