#
# Thread to listen for hosts
#
require 'resolv'

#
#	monitor custom
#
def tmonitorcustom()
	Thread.start {
   	while $config.custom_mon=="true"
			  puts "in tmonitorcustom every #{$config.port_mon_delay} second"
			  sleep($config.port_mon_delay.to_i)
			  puts "go in tmonitorcustom!!!"
			  $host.each_key {|ip|
					if $config.custom_mon=="false"
						break
					end
				  if $host[ip].status != UNMANAGED
					  test_monitored_custom(ip)
				  end
			  }
		end
	}
end

#
#	monitor snmp oid refs
#
def tmonitorsnmp()
	Thread.start {
   	while $config.snmp_mon=="true"
		  puts "in tmonitorsnmp every #{$config.port_mon_delay} second"
		  sleep($config.port_mon_delay.to_i)
		  puts "go in tmonitorsnmp!!!"
		  $host.each_key {|ip|
				if $config.snmp_mon=="false"
					break
				end
				if $host[ip].status != UNMANAGED
					test_monitored_snmp(ip)
				end
		  }
		end
	}
end

#
#	monitor service status
#
def tmonitorport()
	Thread.start {
   	while $config.port_mon=="true"
			puts "in tmonitorport every #{$config.port_mon_delay} second"
			sleep($config.port_mon_delay.to_i)
			puts "go in tmonitorport!!!"
			#retry already known hosts, if NORMAL test his monitored ports
			$host.each_key {|ip|
				if $config.port_mon=="false"
					break
				end
			if $host[ip].status != UNMANAGED
				#puts "trying .... #{ip}"
				if ping(ip)
					#test monitored ports
					if $host[ip].service.size() > 0
						if ! test_monitored_ports(ip)  #all monitored ports are not ok
							$host[ip].set_avail_severity(MAJOR)
						else
		       			#all port are ok and we test old host status
				      	 if $host[ip].status != NORMAL && $host[ip].status != MINOR #not up
								$host[ip].set_avail_severity(NORMAL)
				       	end
		     			end
					else
		    			#host is up and we dont monitor any of his ports
		    			if $host[ip].status != NORMAL  && $host[ip].status != MINOR #not up
 						 $host[ip].set_avail_severity(NORMAL)
                   $event_win.add_event("core", "INFO", "#{$host[ip].ip}", "Host is back")
		    			end
					end
				else
		 		if $host[ip].status != CRITICAL #not down
					$host[ip].set_avail_severity(CRITICAL)
               $event_win.add_event("core", "PANIC", "#{ip}", "Host may be down")
				end
	       end
			end
	  } #each
			puts "dans tmonitorport fin"
       end
       }
end

#
#  try to find os for given ip
#
def tresolvos
	Thread.start {
		while $config.node_resolving == "true"
			puts "in tresolos #{$config.node_resolving_delay.to_i} second"
			sleep($config.node_resolving_delay.to_i) #wait before all window are maps
			$host.each_key {|ip|
				if $config.node_resolving=="false"
					break
				end
puts "for #{ip}"
				if ($host[ip].os == "unknown") && ($host[ip].status != CRITICAL) && ($host[ip].status != UNMANAGED)
					begin
						timeout($config.node_resolving_delay.to_i) {
				       		Thread.start {
				        	  res=osfingerprint("#{ip}")
						 	  if res != "" && res != nil
						  	 	$host[ip].os = res
								$host[ip].change_label()
                        $host[ip].reload
							  end
           					}
				        sleep(10)
    					}
  					rescue
						print "difficulty to find os for #{ip}","\n"
					end					
				end
			}
         sleep($config.node_resolving_delay.to_i)
		end
	}
end

#
#  try to find a netbios name for an IP
#
def tresolvnetbiosname
	Thread.start {
		while $config.node_resolving == "true"
			sleep($config.node_resolving_delay.to_i) #wait before all window are maps
			$host.each_key {|ip|
				if $config.node_resolving=="false"
					break
				end
				if $host[ip].netbios_name == "(noname)"
					begin
						timeout($config.node_resolving_delay.to_i) {
				       		Thread.start {
				        	  		res=ip2netbiosname("#{ip}")
						 	  		if res != nil 
						  	 			$host[ip].netbios_name = res
										$host[ip].change_label()
							  		end
           					}
				        sleep(5)
    					}
  					rescue
						print "difficulty to resolv #{ip} netbios name","\n"
					end
					
				end
			}
         sleep($config.node_resolving_delay.to_i)
		end
	}
end

#
# try to find a name for an IP
#
def tresolvip
	Thread.start {
		while $config.node_resolving == "true"
				  puts "in tresolvip every #{$config.node_resolving_delay.to_i} second"
				  sleep($config.node_resolving_delay.to_i) #wait before all window are maps
				  $host.each_key {|ip|
						if $config.node_resolving=="false"
							break
						end
					  if !$host[ip].dns_name?
						  begin
							  timeout($config.node_resolving_delay.to_i) {
				       			  Thread.start {
								  puts "in resolv ip #{ip}"
				        			 res=Resolv.getname("#{ip}").to_s
						 			 if res != ""
									  puts "resolved! #{res}"
						  	 		  $host[ip].dns_name = res
										$host[ip].change_label()
									 end
           						  }
				      		 sleep(5)
    						  }
  						  rescue
							  print "difficulty to resolv #{ip}, add it to your /etc/hosts file","\n"
						  end
					  end
				  }
          sleep($config.node_resolving_delay.to_i)
		end
	}
end

#
# try to find a mac address for an IP
#
def tmacip
	Thread.start {
		while $config.mac_state == "true"
			sleep($config.mac_delay.to_i) #wait before all window are maps
			$host.each_key {|ip|
				if $config.mac_state=="false"
					break
				end
				if $host[ip].mac == "(noarp)"
					begin
						timeout($config.mac_delay.to_i) {
				       		Thread.start {
				        	  res=mac(ip)
						  if res != ""
                   		$host[ip].mac = res
								$host[ip].change_label()
						    print "we changed mac @\n"
						  end
           					}
				        sleep(5)
    					}
  					rescue
						print "difficulty to find MAC address for #{ip}","\n"
					end
                else
    	    	  if  $config.mac_lock == "true" #we verify mac address
                    begin
                    print "we verify mac address\n"
                    timeout($config.mac_delay.to_i) {
				       		Thread.start {
				        	  res=mac(ip)
						 	  if res != ""
                                if $host[ip].mac != res && $host[ip].status != CRITICAL
											$host[ip].set_avail_severity(MINOR)
                                 $event_win.add_event("core", "WARN", "#{ip}", "Host MAC@ changed")
                                else
                                  if $host[ip].status == MINOR
												$host[ip].set_avail_severity(CRITICAL)
                                  end
                                end
							  end
           					}
				        sleep(5)
    					}
                      rescue
                      end
                  end
				end
			}
         sleep($config.mac_delay.to_i)
		end
	}
end

#
# try to find new host in another network
#
def tfindremotehost(map, mask)
  Thread.start {
	puts "here in tfindremotehost"
	  lhost=broadcast_remote_ping(map, mask)
	  for ip in lhost
	    puts "#{ip} dans tfindremotehost"
	    add_host_entry_with_map(ip, mask, map)
	  end
  }
end

def t_find_remote_new_host()
  Thread.start {
		while $config.broadcast_ping_state == "true"
				sleep($config.broadcast_ping_delay.to_i)
				puts "here in tfindremotehost"
				$network.each_value {|node|
					if $config.broadcast_ping_state=="false"
						break
					end
					if node.ip != ROOTMAPADDR
	  				  lhost=broadcast_remote_ping(node.ip, node.mask)
	  				  for ip in lhost
	    				  puts "#{ip} dans t_find_remote_new_host"
	   		 		  add_host_entry_with_map(ip, node.mask, node.ip)
	 				  end
					end
				}
            sleep($config.broadcast_ping_delay.to_i)
		end
  }	
end

#
# try to find new host in a given range IP addr
#
def tfindrangeremotehost(ip_begin, ip_end)
  Thread.start {
	puts "here in tfindrangeremotehost"
	  lhost=range_remote_ping(ip_begin, ip_end)
	  for ip in lhost
	    puts "#{ip} dans tfindrangeremotehost"
	    add_host_entry(ip, 24)
	  end
  }
end

#
# listen for new host in local network (broadcast)
#
def tfindlocalhost()
	Thread.start {
		while $config.broadcast_ping_state == "true"
			sleep($config.broadcast_ping_delay.to_i)
			for ip in broadcast_ping
				addhostentry("#{ip}", masklocal())
			end
			sleep($config.broadcast_ping_delay.to_i)
		end	
	}
end

#
# To know if we already know this ip
#
def contain (iplocal)
	i=0
	$host.each_key{|ip|	
		if ip == iplocal
			return i
		end
	i=i+1
	}
return -1
end

#
# Add new lign entry > pixmap & host-ip-button
#
def add_host_entry_with_map(ip, mask, map)
	#if host doesnt exist in array
puts "add_host_entry_with_map host to add #{ip} in #{map}"
print map ," ",mask, " ",get_map(), "\n"
	add_network(map, mask, get_map())
	if $host[ip] == nil
	   $event_win.add_event("core", "INFO", "#{ip}", "Find new host")
		add_host(ip,mask,map)
	end
end

#
# Add new lign entry > pixmap & host-ip-button
#
def addhostentry(ip, mask)
	#if host doesnt exist in array
	if $host[ip] == nil
		puts "host wo map to add #{ip}"
	   $event_win.add_event("core", "INFO", "#{ip}", "Find new host")
		add_host(ip,mask)
	end
end

#
# snmp discovery
# read arp, route from a snmp host

def tsnmp
#atNetAddress
#ipRouteNextHop
end
