#
# module to use snmp linux command
# require linux ucd-snmp-utils package
#
require 'timeout'
require "#{GNMSLIB}"+'module/config_global'

#
#	return the value of the entry
#
def getSnmpOID(node, oid)
#snmpget -v 2c -c public2balle localhost UCD-SNMP-MIB::ssCpuUser.0
  if $config.snmpget_path == ""
    return "Error"
  end
  result=`#{$config.snmpget} -v 2c -c #{node.snmpread} #{node.ip} #{oid}`
#test if first arg is the oid else error!
  if result == ""
    return "Error"	
  end
  tresult=result.chomp.split(/ = /)
  ttresult=tresult[1].split(/: /)
  return ttresult[1]
end

#
# Return uptime of an host
#
def getUptime (node, community, entry)
  Thread.start {
  if $config.snmpget_path == "" || node.status == CRITICAL
    return "Error"
  end
	result=`#{$config.snmpget} -v 2c -c #{community} #{node.ip}  sysUpTime.0`
    if result == ""
      return "Error"	
    end
      tresult=result.chomp.split(/ = /)
	   ttresult=tresult[1].split(/: /)
      entry.set_position 0
      entry.set_text ttresult[1]
    #return tresult[1]
    }
end

#
# Return location of an host
#
def getLocation (node, community, entry)
  Thread.start {
  if $config.snmpget_path == "" || node.status == CRITICAL
    return "Error"
  end
	result=`#{$config.snmpget} -v 2c -c #{community} #{node.ip} sysLocation.0`
    if result == ""
      return "Error"	
    end
    tresult=result.chomp.split(/ = /)
	 ttresult=tresult[1].split(/: /)
    entry.set_position 0
	 entry.set_text ttresult[1]
    #return tresult[1]
    }
end

#
# Return contact of an host
#
def getContact (node, community, entry)
  Thread.start {
    if $config.snmpget_path == "" || node.status == CRITICAL
      return "Error"
    end

    result=`#{$config.snmpget} -v 2c -c #{community} #{node.ip} sysContact.0`
    if result == ""
      return "Error"	
    end
    tresult=result.chomp.split(/ = /)
	 ttresult=tresult[1].split(/: /)
    entry.set_position 0
    entry.set_text ttresult[1]
    }
end

#
# Return the description of an host
#
def getDescription (node, community, entry)
    Thread.start {
    p "here snmp"
    if $config.snmpget_path == "" || node.status == CRITICAL
      return "Error"
    end

	result=`#{$config.snmpget} -v 2c -c #{community} #{node.ip}  sysDescr.0`
   tresult=result.chomp.split(/ = /)
   ttresult=tresult[1].split(/: /)
   entry.text=ttresult[1]
   entry.set_position 0
     }
end

#
# Return the name of a node
#
def getName (host, community)
    
    if $config.snmpget_path == "" || $host[host].status == CRITICAL
      return "Error"
    end

	result=`#{$config.snmpget} -v 2c -c #{community} #{host} sysName.0`
	tresult=result.chomp.split(/ = /)
   ttresult=tresult[1].split(/: /)
	return ttresult[1]
end

#
# Return the MAC address of the ip give in argument,
# use snmp
#
def mac(ip)
  #first try to solve it by the help of local arp table
  temp=mac_tablelocal(ip)
  print ">>>>>>>",temp.chomp,"<<<<<<<",ip,"\n"
  if (temp!="")
    return temp.chomp
  end

  if $config.snmp_mon == "false" || $config.snmpget_path == "" || $host[ip].status == CRITICAL
      return ""
  end
    
  ind=`#{$config.snmpget} -c public #{ip} ipAdEntIfIndex.#{ip}`
  indl=ind.split(/ = /)
  if indl.size != 2
    return
  end
  ind=`#{$config.snmpget} -c public  #{ip} ifPhysAddress.#{indl[1]}`
  indl=ind.split(/ = /)
  ttresult=indl[1].split(/: /)
  result=ttresult[1].chomp
puts "sortant"
  return result
end
